init()
{
	level.jogadortop = undefined;
	thread update();
	
}
update()
{
	melhormatador = read_melhormatador();

	players = getentarray("player", "classname");
	for(;;)
	{
		//update cvars for best players and save to files
		level.jogadortop = "";
		for (i=0; i<melhormatador.size; i++)
		{
				level.jogadortop += (i+1)+"^7. "+melhormatador[i].name+"  ^3Total ^1Kills:^2 "+melhormatador[i].pers["totkills"]+"\n^7";
				self setClientCvar("toplvl", level.jogadortop);
		}
		
		for(i = 0; i < players.size; i++)
		{
			if(isDefined(level.jogadortop))
			{
				players[i] setClientCvar("toplvl", level.jogadortop);

			}
		}
		
		players = getentarray("player", "classname");
		for(i = 0; i < players.size; i++)
		{
			last_index = -1;
			// try to update pers["totkills"] of an existing player
			updated = false;
			for (j=0; j<melhormatador.size; j++)
			{
				if (melhormatador[j].name == players[i].name)
				{
					if (melhormatador[j].pers["totkills"] < players[i].pers["totkills"])
					{
						last_index = j;
						melhormatador[j].pers["totkills"] = players[i].pers["totkills"];
					}
					updated = true;
					break;
				}
			}
			if (!updated) // else add him on the list if he is better than the last in the list
			{
				last_index = melhormatador.size - 1;
				if (melhormatador[last_index].pers["totkills"] < players[i].pers["totkills"])
				{
					melhormatador[last_index].name = players[i].name;
					melhormatador[last_index].pers["totkills"] = players[i].pers["totkills"];
				}
			}
			
			// sort this list
			j = last_index;
			while (j>0 && melhormatador[j-1].pers["totkills"] < melhormatador[j].pers["totkills"])
			{
				tmp = melhormatador[j];
				melhormatador[j] = melhormatador[j-1];
				melhormatador[j-1] = tmp;
				
				j--;
			}
		}
		
		write_melhormatador(melhormatador);
		wait 60;

	}
}

read_melhormatador()
{
	melhormatador = [];
	f = openfile("toplvl.txt", "read");
	if (f != -1)
	{
		i = 0;
		n = freadln(f);
		while(n >=0)
		{
			if (n == 2)
			{
				melhormatador[i] = spawnStruct();
				melhormatador[i].name = fGetArg(f, 0);
				melhormatador[i].pers["totkills"] = int(fGetArg(f, 1));
				i++;
			}
			self setClientCvar("toplvl", level.jogadortop);
			n = freadln(f);
		}
	}
	else
	{
		for (i=0; i<1; i++)
		{
			melhormatador[i] = spawnStruct();
			melhormatador[i].name = "^7none";
			melhormatador[i].pers["totkills"] = 0;
		}
		write_melhormatador(melhormatador);
	}
	closefile(f);
	return melhormatador;
}

write_melhormatador(melhormatador)
{
	str = "";
	for (i=0; i<melhormatador.size; i++)
		if (i<melhormatador.size-1)
			str += melhormatador[i].name+","+melhormatador[i].pers["totkills"]+",\n";
		else
			str += melhormatador[i].name+","+melhormatador[i].pers["totkills"];
	f = openfile("toplvl.txt", "write");
	fPrintln(f, str);
	closefile(f);
}
