init()
{

	game["menu_quickcommands"] = "quickcommands";
	game["menu_quickstatements"] = "quickstatements";
	game["menu_quickresponses"] = "quickresponses";

	precacheMenu(game["menu_quickcommands"]);
	precacheMenu(game["menu_quickstatements"]);
	precacheMenu(game["menu_quickresponses"]);
	precacheHeadIcon("talkingicon");

	level._quickmsg=[];
	addmsg(0,1,&"QUICKMESSAGE_FOLLOW_ME",&"QUICKMESSAGEENG_FOLLOW_ME","_mp_cmd_followme");
	addmsg(0,2,&"QUICKMESSAGE_MOVE_IN",&"QUICKMESSAGEENG_MOVE_IN","_mp_cmd_movein");
	addmsg(0,3,&"QUICKMESSAGE_FALL_BACK",&"QUICKMESSAGEENG_FALL_BACK","_mp_cmd_fallback");
	addmsg(0,4,&"QUICKMESSAGE_SUPPRESSING_FIRE",&"QUICKMESSAGEENG_SUPPRESSING_FIRE","_mp_cmd_suppressfire");
	addmsg(0,5,&"QUICKMESSAGE_ATTACK_LEFT_FLANK",&"QUICKMESSAGEENG_ATTACK_LEFT_FLANK","_mp_cmd_attackleftflank");
	addmsg(0,6,&"QUICKMESSAGE_ATTACK_RIGHT_FLANK",&"QUICKMESSAGEENG_ATTACK_RIGHT_FLANK","_mp_cmd_attackrightflank");
	addmsg(0,7,&"QUICKMESSAGE_HOLD_THIS_POSITION",&"QUICKMESSAGEENG_HOLD_THIS_POSITION","_mp_cmd_holdposition");
	addmsg(0,8,&"QUICKMESSAGE_REGROUP",&"QUICKMESSAGEENG_REGROUP","_mp_cmd_regroup");

	addmsg(1,1,&"QUICKMESSAGE_ENEMY_SPOTTED",&"QUICKMESSAGEENG_ENEMY_SPOTTED","_mp_stm_enemyspotted");
	addmsg(1,2,&"QUICKMESSAGE_ENEMY_DOWN",&"QUICKMESSAGEENG_ENEMY_DOWN","_mp_stm_enemydown");
	addmsg(1,3,&"QUICKMESSAGE_IM_IN_POSITION",&"QUICKMESSAGEENG_IM_IN_POSITION","_mp_stm_iminposition");
	addmsg(1,4,&"QUICKMESSAGE_AREA_SECURE",&"QUICKMESSAGEENG_AREA_SECURE","_mp_stm_areasecure");
	addmsg(1,5,&"QUICKMESSAGE_GRENADE",&"QUICKMESSAGEENG_GRENADE","_mp_stm_grenade");
	addmsg(1,6,&"QUICKMESSAGE_SNIPER",&"QUICKMESSAGEENG_SNIPER","_mp_stm_sniper");
	addmsg(1,7,&"QUICKMESSAGE_NEED_REINFORCEMENTS",&"QUICKMESSAGEENG_NEED_REINFORCEMENTS","_mp_stm_needreinforcements");
	addmsg(1,8,&"QUICKMESSAGE_HOLD_YOUR_FIRE",&"QUICKMESSAGEENG_HOLD_YOUR_FIRE","_mp_stm_holdyourfire");

	addmsg(2,1,&"QUICKMESSAGE_YES_SIR",&"QUICKMESSAGEENG_YES_SIR","_mp_rsp_yessir");
	addmsg(2,2,&"QUICKMESSAGE_NO_SIR",&"QUICKMESSAGEENG_NO_SIR","_mp_rsp_nosir");
	addmsg(2,3,&"QUICKMESSAGE_IM_ON_MY_WAY",&"QUICKMESSAGEENG_IM_ON_MY_WAY","_mp_rsp_onmyway");
	addmsg(2,4,&"QUICKMESSAGE_SORRY",&"QUICKMESSAGEENG_SORRY","_mp_rsp_sorry");
	addmsg(2,5,&"QUICKMESSAGE_GREAT_SHOT",&"QUICKMESSAGEENG_GREAT_SHOT","_mp_rsp_greatshot");
	addmsg(2,6,&"QUICKMESSAGE_TOOK_LONG_ENOUGH",&"QUICKMESSAGEENG_TOOK_LONG_ENOUGH","_mp_rsp_tooklongenough");
	addmsg(2,7,&"QUICKMESSAGE_ARE_YOU_CRAZY",&"QUICKMESSAGEENG_ARE_YOU_CRAZY","_mp_rsp_areyoucrazy");

	addmsg(3,1,&"QUICKMESSAGE_HELLO",&"QUICKMESSAGEENG_HELLO","null");
	addmsg(3,2,&"QUICKMESSAGE_TY",&"QUICKMESSAGEENG_TY","null");
	addmsg(3,3,&"QUICKMESSAGE_NP",&"QUICKMESSAGEENG_NP","null");
	addmsg(3,4,&"QUICKMESSAGE_BO",&"QUICKMESSAGEENG_BO","null");
	addmsg(3,5,&"QUICKMESSAGE_LEARN2PLAY",&"QUICKMESSAGEENG_LEARN2PLAY","null");

	addmsg(4,1,&"QUICKMESSAGE_XD",&"QUICKMESSAGE_XD","null");
	addmsg(4,2,&"QUICKMESSAGE_WTF",&"QUICKMESSAGE_WTF","null");
	addmsg(4,3,&"QUICKMESSAGE_OMFG",&"QUICKMESSAGE_OMFG","null");
	addmsg(4,4,&"QUICKMESSAGE_LOL",&"QUICKMESSAGE_LOL","null");
	addmsg(4,5,&"QUICKMESSAGE_D",&"QUICKMESSAGE_D","null");
	addmsg(4,6,&"QUICKMESSAGE_P",&"QUICKMESSAGE_P","null");
	addmsg(4,7,&"QUICKMESSAGE_SERIOUS",&"QUICKMESSAGE_SERIOUS","null");
}
addmsg(v1,v2,str,streng,sound)
{
	level._quickmsg[v1][v2] = spawnstruct();
	level._quickmsg[v1][v2].text=str;
	level._quickmsg[v1][v2].texteng=streng;
	level._quickmsg[v1][v2].soundalias=sound;
}

quickcommands(response)
{
	if(!isdefined(self.pers["team"]) || self.pers["team"] == "spectator" || isdefined(self.spamdelay))
		return;

	self.spamdelay = true;

	if(self.english)
		saytext=level._quickmsg[0][int(response)].texteng;
	else
		saytext=level._quickmsg[0][int(response)].text;
	alias=level._quickmsg[0][int(response)].soundalias;
	if(self.pers["team"] == "allies")
	{
		switch(game["allies"])		
		{
		case "american":
			soundalias = "US"+alias;
			break;

		case "british":
			soundalias = "UK"+alias;
			break;

		default:
			soundalias = "RU"+alias;
			break;
		}
	}
	else
	{
		soundalias = "GE"+alias;
	}

	self saveHeadIcon();
	self doQuickMessage(soundalias, saytext);

	wait 2;
	self.spamdelay = undefined;
	self restoreHeadIcon();	
}

quickstatements(response)
{
	if(!isdefined(self.pers["team"]) || self.pers["team"] == "spectator" || isdefined(self.spamdelay))
		return;

	self.spamdelay = true;
	
	if(self.english)
		saytext=level._quickmsg[1][int(response)].texteng;
	else
		saytext=level._quickmsg[1][int(response)].text;
	alias=level._quickmsg[1][int(response)].soundalias;
	if(self.pers["team"] == "allies")
	{
		switch(game["allies"])		
		{
		case "american":
			alias = "US"+alias;
			break;

		case "british":
			alias = "UK"+alias;
			break;

		default:
			alias = "RU"+alias;
			break;
		}
	}
	else
	{
		alias = "GE"+alias;
	}

	self saveHeadIcon();
	self doQuickMessage(alias, saytext);

	wait 2;
	self.spamdelay = undefined;
	self restoreHeadIcon();
}

quickresponses(response)
{
	if(!isdefined(self.pers["team"]) || self.pers["team"] == "spectator" || isdefined(self.spamdelay))
		return;

	self.spamdelay = true;

	if(self.english)
		saytext=level._quickmsg[2][int(response)].texteng;
	else
		saytext=level._quickmsg[2][int(response)].text;
	alias=level._quickmsg[2][int(response)].soundalias;
	if(self.pers["team"] == "allies")
	{
		switch(game["allies"])
		{
		case "american":
			alias = "US"+alias;
			break;

		case "british":
			alias = "UK"+alias;
			break;

		default:
			alias = "RU"+alias;
			break;
		}
	}
	else
	{
		alias = "GE"+alias;
	}

	self saveHeadIcon();
	self doQuickMessage(alias, saytext);

	wait 2;
	self.spamdelay = undefined;
	self restoreHeadIcon();
}

extramsgs(response)
{
	if(!isdefined(self.pers["team"]) || self.pers["team"] == "spectator" || isdefined(self.spamdelay))
		return;

	self.spamdelay = true;

	if(self.english)
		saytext=level._quickmsg[3][int(response)].texteng;
	else
		saytext=level._quickmsg[3][int(response)].text;

	self saveHeadIcon();
	self doQuickMessage("null", saytext);

	wait 1;
	self.spamdelay = undefined;
	self restoreHeadIcon();	
}

smileys(response)
{
	if(!isdefined(self.pers["team"]) || self.pers["team"] == "spectator" || isdefined(self.spamdelay))
		return;

	self.spamdelay = true;

	saytext=level._quickmsg[4][int(response)].text;

	self saveHeadIcon();
	self doQuickMessage("null", saytext);

	wait 1;
	self.spamdelay = undefined;
	self restoreHeadIcon();	
}

doQuickMessage(soundalias, saytext)
{
	if(self.sessionstate != "playing")
		return;

	if(isdefined(level.QuickMessageToAll) && level.QuickMessageToAll)
	{
		self.headiconteam = "none";
		self.headicon = "talkingicon";

		self playSound(soundalias);
		self sayAll(saytext);
	}
	else
	{
		if(self.sessionteam == "allies")
			self.headiconteam = "allies";
		else if(self.sessionteam == "axis")
			self.headiconteam = "axis";
		
		self.headicon = "talkingicon";

		self playSound(soundalias);
		self sayTeam(saytext);
		self pingPlayer();
	}
}

saveHeadIcon()
{
	if(isdefined(self.headicon))
		self.oldheadicon = self.headicon;

	if(isdefined(self.headiconteam))
		self.oldheadiconteam = self.headiconteam;
}

restoreHeadIcon()
{
	if(isdefined(self.oldheadicon))
		self.headicon = self.oldheadicon;

	if(isdefined(self.oldheadiconteam))
		self.headiconteam = self.oldheadiconteam;
}