#include ER_zumbis\_ER_utils;
#include maps\mp\_utility;
init()
{
	thread maps\mp\gametypes\_objpoints::init();
    thread ER_zumbis\_ER_precache::init();
				
	thread ER_zumbis\_login::autosave();
	thread ER_zumbis\_lvlmaisalto::init();
	thread cvars();
	
	level.nospawnedweapons = getcvarint("nospawnedweapons");
	level.camperkilltime = getcvarint("sv_hunters_time");
	
	level.superzomchance=getcvarint("sv_zomchance");
	level.servername=getcvar("sv_nameyour_server");
	level.dropitens=2;
	level.mapcenter=[];
	lowpoint[0]=10000;
	lowpoint[1]=10000;
	lowpoint[2]=10000;
	hipoint[0]=-10000;
	hipoint[1]=-10000;
	hipoint[2]=-10000;
	spawns = getentarray("mp_tdm_spawn","classname");
	level.sporg=[];
	for(i=0;i<spawns.size;i++)
	{
		for(x=0;x<3;x++)
		{
			if(spawns[i].origin[x]<lowpoint[x])
				lowpoint[x]=spawns[i].origin[x];
			else if(spawns[i].origin[x]>hipoint[x])
				hipoint[x]=spawns[i].origin[x];
		}
	}
	temp=[];
	for(x=0;x<3;x++)
	{
		temp[x]=(lowpoint[x]+hipoint[x]) / 2.0;
	}
	level.mapcenter=(temp[0],temp[1],temp[2]);
	best=0;
	for(i=0;i<spawns.size;i++)
	{
		if(distance(level.mapcenter,spawns[i].origin)>best)
		best=distance(level.mapcenter,spawns[i].origin);
	}
	level.mapradius=best;
	map = getcvar("mapname");
	
       level.sentryMP = 0;
       level.bolhaMP = 0;
       level.metralhaMP = 0;
       level.missilMP = 0;
       level.minaMP = 0;
	   level.doublep="";
	   level.spawned_m="";

	   level.miniuse=0;
	   level.rocketuse=0;
	   level.crossuse=0;
	   level.teslause=0;
	   level.raygunuse=0;
	   level.r700use=0;
	   level.facause=0;
	   level.beneliuse=0;
	   level.ak47=0;
	   
	   level._str["money"]="^2$";
	   level._str["gotmoney"]="^2you got money ";
	   addlstring("/",&"/");
	   addlstring("",&"");
	   
	   setcvar("cash", "");
	   setcvar("givemoney", "");
	   
	   	if(getcvarint("sv_ambient_soundOFF"=="1"))
		AmbientStop(0);

	if(getcvarint("scr_zom_fog"))
	{
		SetExpFog(getcvarfloat("scr_zom_fog_d"), getcvarfloat("scr_zom_fog_r"), getcvarfloat("scr_zom_fog_g"), getcvarfloat("scr_zom_fog_b"), 1);
	}
	   
}
cvars()
{
	if(getCvar("sv_nameyour_server") == "")
		setCvar("sv_nameyour_server", "^2ZOMBIE ACCOUNT SYSTEM SERVER ^4,^2 MOD BY :^6ER");
		
		if(getCvar("sv_hunters_time") == "")
		setCvar("sv_hunters_time", "900");	
		
			if(getCvar("sv_delay_night") == "")
		setCvar("sv_delay_night", "200");	
		
		if(getCvar("sv_max_faca") == "")
		setCvar("sv_max_faca", "64");		
		if(getCvar("sv_max_minigun") == "")
		setCvar("sv_max_minigun", "64");
		
		if(getCvar("sv_max_rocket") == "")
		setCvar("sv_max_rocket", "64");	
		if(getCvar("sv_max_cross") == "")
		setCvar("sv_max_cross", "64");
		
		if(getCvar("sv_max_tesla") == "")
		setCvar("sv_max_tesla", "64");		
		if(getCvar("sv_max_raygun") == "")
		setCvar("sv_ambient_soundOFF", "64");
		
		if(getCvar("sv_max_r700") == "")
		setCvar("sv_max_r700", "64");	
		if(getCvar("sv_max_beneli") == "")
		setCvar("sv_max_beneli", "64");
		
		if(getCvar("sv_ambient_soundOFF") == "")
		setCvar("sv_ambient_soundOFF", "1");			
		if(getCvar("sv_night_time") == "")
		setCvar("sv_night_time", "180");
		
	    if(getCvar("sv_zomchance") == "")
		setCvar("sv_zomchance", "2");		
		if(getCvar("sv_r700_lvl") == "")
		setCvar("sv_r700_lvl", "20");
		
		if(getCvar("sv_ak47_lvl") == "")
		setCvar("sv_ak47_lvl", "10");		
		if(getCvar("sv_raygun_lvl") == "")
		setCvar("sv_raygun_lvl", "70");
		
		if(getCvar("sv_teslashock_lvl") == "")
		setCvar("sv_teslashock_lvl", "55");		
		if(getCvar("sv_crossbow_lvl") == "")
		setCvar("sv_crossbow_lvl", "30");
		
		if(getCvar("sv_rocket_lvl") == "")
		setCvar("sv_rocket_lvl", "20");		
		if(getCvar("sv_minigun_lvl") == "")
		setCvar("sv_minigun_lvl", "40");
		
		if(getCvar("sv_knives_lvl") == "")
		setCvar("sv_knives_lvl", "10");		
		if(getCvar("sv_beneli_lvl") == "")
		setCvar("sv_beneli_lvl", "60");
		
		
	if(getCvar("scr_zom_alivepointdistance") == "")
		setCvar("scr_zom_alivepointdistance", "900");
	if(getCvar("scr_zom_positiontime") == "")
		setCvar("scr_zom_positiontime", "6");

	if(getCvar("scr_zom_respawndelay") == "")
		setCvar("scr_zom_respawndelay", "0");
	if(getCvar("scr_zom_showoncompass") == "")
	
		setCvar("scr_zom_showoncompass", "1");
	if(getCvar("scr_zom_showasobjpoint") == "")
		setCvar("scr_zom_showasobjpoint", "1");

	if(getcvar("scr_zom_returnkills") == "")
		setcvar("scr_zom_returnkills", "2");

	if(getcvar("scr_zom_fog") == "")
		setcvar("scr_zom_fog", "1");
	if(getcvar("scr_zom_fog_r") == "")
		setcvar("scr_zom_fog_r", "0");
	if(getcvar("scr_zom_fog_g") == "")
		setcvar("scr_zom_fog_g", "0");
	if(getcvar("scr_zom_fog_b") == "")
		setcvar("scr_zom_fog_b", "0");
	if(getcvar("scr_zom_fog_d") == "")
		setcvar("scr_zom_fog_d", "0.001");

	if(getcvar("scr_zom_axisHealth") == "")
		setcvar("scr_zom_axisHealth", "100");
	if(getcvar("scr_zom_alliesHealth") == "")
		setcvar("scr_zom_alliesHealth", "100");

	if(getcvar("scr_zom_axisSpeed") == "")
		setcvar("scr_zom_axisSpeed", "220");
	if(getcvar("scr_zom_alliesSpeed") == "")
		setcvar("scr_zom_alliesSpeed", "170");

	if(getcvar("scr_zom_axisNades") == "")
		setcvar("scr_zom_axisNades", "1");
	if(getcvar("scr_zom_alliesNades") == "")
		setcvar("scr_zom_alliesNades", "0");

	if(getcvar("scr_zom_axisSmoke") == "")
		setcvar("scr_zom_axisSmoke", "1");
	if(getcvar("scr_zom_alliesSmoke") == "")
		setcvar("scr_zom_alliesSmoke", "0");

	if(getcvar("scr_zom_alliesPistol") == "")
		setcvar("scr_zom_alliesPistol", "1");
	if(getcvar("scr_zom_axisPistol") == "")
		setcvar("scr_zom_axisPistol", "1");

	if(getcvar("scr_zom_alliesMeleeOnly") == "")
		setcvar("scr_zom_alliesMeleeOnly", "0");
	if(getcvar("scr_zom_axisMeleeOnly") == "")
		setcvar("scr_zom_axisMeleeOnly", "0");

	if(getcvar("scr_zom_alliesOverrideNades") == "")
		setcvar("scr_zom_alliesOverrideNades", "0");
	if(getcvar("scr_zom_axisOverrideNades") == "")
		setcvar("scr_zom_axisOverrideNades", "0");

	if(getcvar("scr_zom_tktimeout") == "")
		setcvar("scr_zom_tktimeout", "3");

	if(getcvar("scr_zom_alliesPointsForKilling") == "")
		setcvar("scr_zom_alliesPointsForKilling", "1");
	if(getcvar("scr_zom_axisPointsForKilling") == "")
		setcvar("scr_zom_axisPointsForKilling", "1");

	if(getcvar("scr_zom_NoTeamChange") == "")
		setcvar("scr_zom_NoTeamChange", "1");
	if(getcvar("scr_zom_teambalance") == "")
		setcvar("scr_zom_teambalance", "0");

	if(getcvar("scr_zom_alliesDropWeapons") == "")
		setcvar("scr_zom_alliesDropWeapons", "0");
	if(getcvar("scr_zom_axisDropWeapons") == "")
		setcvar("scr_zom_axisDropWeapons", "0");

	if(getcvar("scr_zom_lastManStanding") == "")
		setcvar("scr_zom_lastManStanding", "1");
	if(getcvar("scr_zom_randomZombie") == "")
		setcvar("scr_zom_randomZombie", "0");
	if(getcvar("scr_zom_healthMultiplier") == "")
		setcvar("scr_zom_healthMultiplier", "2");
		
	if(getcvar("scr_map_vote") == "")
		setcvar("scr_map_vote", "1"); 		
	if(getcvar("scr_map_vote_time") == "")
		setcvar("scr_map_vote_time", "20"); 
		
	if(getcvar("scr_map_vote_replay") == "")
		setcvar("scr_map_vote_replay", "0"); 
	if(getcvar("sv_spawnprotection") == "")
		setcvar("sv_spawnprotection", "1"); 
	
		if(getcvar("scr_mine_price") == "")
		setcvar("scr_mine_price", "250");	
		if(getcvar("scr_bolha_price") == "")
		setcvar("scr_bolha_price", "650");
	
		if(getcvar("scr_mg42_price") == "")
		setcvar("scr_mg42_price", "650");	
		if(getcvar("scr_granada_price") == "")
		setcvar("scr_granada_price", "700");
		
		if(getcvar("scr_ammo_price") == "")
		setcvar("scr_ammo_price", "200");	
		if(getcvar("scr_faca_price") == "")
		setcvar("scr_faca_price", "1700");
		
		if(getcvar("scr_bolhalove_price") == "")
		setcvar("scr_bolhalove_price", "900");	
		if(getcvar("scr_sentry_price") == "")
		setcvar("scr_sentry_price", "1500");
		
		if(getcvar("scr_tnt_price") == "")
		setcvar("scr_tnt_price", "500");	
		if(getcvar("scr_missil_price") == "")
		setcvar("scr_missil_price", "800");				
		
		if(getcvar("scr_zumbiaranha_price") == "")
		setcvar("scr_zumbiaranha_price", "200");	
		if(getcvar("scr_superpulo_price") == "")
		setcvar("scr_superpulo_price", "200");
		
		if(getcvar("scr_zumgranada_price") == "")
		setcvar("scr_zumgranada_price", "850");	
		if(getcvar("scr_batata_price") == "")
		setcvar("scr_batata_price", "100");
		
    	if(getcvar("scr_shock_price") == "")
		setcvar("scr_shock_price", "600");			
		if(getcvar("scr_zumspeed_price") == "")
		setcvar("scr_zumspeed_price", "200");		
		
		if(getcvar("scr_r700_price") == "")
		setcvar("scr_r700_price", "2500");		
		if(getcvar("scr_ak47_price") == "")
		setcvar("scr_ak47_price", "400");
		
		if(getcvar("scr_raygun_price") == "")
		setcvar("scr_raygun_price", "3000");		
	   if(getcvar("scr_teslashock_price") == "")
		setcvar("scr_teslashock_price", "2500");
		
		if(getcvar("scr_crossbow_price") == "")
		setcvar("scr_crossbow_price", "1800");	
		if(getcvar("scr_Rocket_price") == "")
		setcvar("scr_Rocket_price", "1800");
		
		if(getcvar("scr_MiniguN_price") == "")
		setcvar("scr_MiniguN_price", "2700");	
		if(getcvar("scr_beneli_price") == "")
		setcvar("scr_beneli_price", "2700");
		
		if(getcvar("sv_moneyfor_melee_kill") == "")
		setcvar("sv_moneyfor_melee_kill", "70");	
		if(getcvar("sv_adm_moneyfor_head_kill") == "")
		setcvar("sv_adm_moneyfor_head_kill", "130");
		
		if(getcvar("sv_moneyfor_kill") == "")
		setcvar("sv_moneyfor_kill", "50");	
		
		if(getcvar("sv_adm_moneyfor_melee_kill") == "")
		setcvar("sv_adm_moneyfor_melee_kill", "100");
		
		if(getcvar("sv_moneyfor_head_kill") == "")
		setcvar("sv_moneyfor_head_kill", "100");	
		if(getcvar("sv_adm_moneyfor_kill") == "")
		setcvar("sv_adm_moneyfor_kill", "80");
		
		if(getcvar("sv_expfor_melee") == "")
		setcvar("sv_expfor_melee", "6500");	
		if(getcvar("sv_expfor_nade") == "")
		setcvar("sv_expfor_nade", "5000");
		
	   if(getcvar("sv_expfor_head") == "")
		setcvar("sv_expfor_head", "8000");	
		if(getcvar("sv_expfor_kill") == "")
		setcvar("sv_expfor_kill", "4000");
		
	  if(getcvar("sv_bubble_delay") == "")
		setcvar("sv_bubble_delay", "10");	
		if(getcvar("sv_sentry_delay") == "")
		setcvar("sv_sentry_delay", "10");
		
	   if(getcvar("sv_mg42_delay") == "")
		setcvar("sv_mg42_delay", "10");	
		if(getcvar("sv_walky_delay") == "")
		setcvar("sv_walky_delay", "10");

		
	level.PositionUpdateTime = getcvarint("scr_zom_positiontime");
	level.lastman=getcvarint("scr_zom_lastManStanding");

	level.objused = [];
	for (i=0;i<16;i++)
		level.objused[i] = false;

	thread ER_zumbis\_commands::init();
}
PlayerConnect()
{

    self.templogin="";
	self.moneytoshow=0;
	self.xpToShow=0;

	
	dopers("login");
	dopers("password");
	dopersint("money");
	dopersint("lvl",1);
	dopersint("xpneeded");
	dopersint("xp");
	dopersint("totkills");
	dopersint("totdeaths");
	dopersint("totbash");
	dopersint("tothead");
	dopersint("totnade"); 
	dopersint("totmons");
	dopersint("totnukes");
	
	dopersint("r700uso");
	dopersint("raygunuso");
	dopersint("teslauso");
	dopersint("crossuso");
	dopersint("rocketuso");
	dopersint("rocketuso");
	dopersint("facauso");
	dopersint("beneliuso");
	dopersint("ak47uso");
	dopersint("streak");
	dopersint("xpheight");
	dopersint("zumbixp");
	dopersint("missildelay");
	dopersint("mg42delay");
	dopersint("sentrydelay");	
	dopersint("bolhadelay");
	dopersint("failpts");
	dopersint("killcount");
	
	dopersint("isadmin");
	dopersint("loggedin");
	dopersint("loginpart");
	dopersint("logintype");
		
	self setclientcvar("loginpart",0);
	self setclientcvar("id","");
	self setclientcvar("pass","");
	
	self setClientCvar( "download", "^2Mod By : ^6Eluan Ramos" );
	self setClientCvar( "cg_drawcrosshair", "0" );
	
	self setclientcvar("buy_h1","^3[1].^2 Mine  "+getcvar("scr_mine_price")+level._str["money"]);
	self setclientcvar("buy_h2","^3[2].^2 Bubble  "+getcvar("scr_bolha_price")+level._str["money"]);
	self setclientcvar("buy_h3","^3[3].^2 MG42  "+getcvar("scr_mg42_price")+level._str["money"]);
	self setclientcvar("buy_h4","^3[4].^2 Sentry Gun  "+getcvar("scr_sentry_price")+level._str["money"]);
	self setclientcvar("buy_h5","^3[5].^2 Grenade  "+getcvar("scr_granada_price")+level._str["money"]);
	self setclientcvar("buy_h6","^3[6].^2 Ammo  "+getcvar("scr_ammo_price")+level._str["money"]);
	self setclientcvar("buy_h7","^3[7].^2 BubbleOfLove "+getcvar("scr_bolhalove_price")+level._str["money"]);
	self setclientcvar("buy_h8","^3[8].^2 Walkyria "+getcvar("scr_missil_price")+level._str["money"]);
	self setclientcvar("buy_h9","^3[9].^2 TNT "+getcvar("scr_tnt_price")+level._str["money"]);	
	
	self setclientcvar("buy_z1","^3[1]^1. Zom Climb^2  "+getcvar("scr_zumbiaranha_price")+level._str["money"]);
	self setclientcvar("buy_z3","^3[3]^1. Zom Shock ^2  "+getcvar("scr_shock_price")+level._str["money"]);	
	self setclientcvar("buy_z2","^3[2]^1. Super jump^2  "+getcvar("scr_superpulo_price")+level._str["money"]);	
	self setclientcvar("buy_z5","^3[5]^1. Grenade^2  "+getcvar("scr_zumgranada_price")+level._str["money"]);	
	self setclientcvar("buy_z4","^3[4]^1. Potatoes^2  "+getcvar("scr_batata_price")+level._str["money"]);	
	self setclientcvar("buy_z6","^3[6]^1. Zom speed^2 "+getcvar("scr_zumspeed_price")+level._str["money"]);	

	
	self setclientcvar("buy_w1","[1]^5R.700 ^3[Lv"+getcvar("sv_r700_lvl")+"]^2  "+getcvar("scr_r700_price")+level._str["money"]);
	self setclientcvar("buy_w2","[2]^5AK47 ^3[Lv"+getcvar("sv_ak47_lvl")+"]^2 "+getcvar("scr_ak47_price")+level._str["money"]);
	self setclientcvar("buy_w3","[3]^5Raygun ^3[Lv"+getcvar("sv_raygun_lvl")+"]^2  "+getcvar("scr_raygun_price")+level._str["money"]);
	self setclientcvar("buy_w4","[4]^5Wunderwaffe ^3[Lv"+getcvar("sv_teslashock_lvl")+"]^2  "+getcvar("scr_teslashock_price")+level._str["money"]);
	self setclientcvar("buy_w5","[5]^5Crossbow ^3[Lv"+getcvar("sv_crossbow_lvl")+"]^2  "+getcvar("scr_crossbow_price")+level._str["money"]);
	self setclientcvar("buy_w6","[6]^5Rocket ^3[Lv"+getcvar("sv_rocket_lvl")+"]^2  "+getcvar("scr_rocket_price")+level._str["money"]);
	self setclientcvar("buy_w7","[7]^5Minigun ^3[Lv"+getcvar("sv_minigun_lvl")+"]^2  "+getcvar("scr_minigun_price")+level._str["money"]);
	self setclientcvar("buy_w8","[8]^5knives ^3[Lv"+getcvar("sv_knives_lvl")+"]^2  "+getcvar("scr_faca_price")+level._str["money"]);
	self setclientcvar("buy_w9","[9]^5Beneli ^3[Lv"+getcvar("sv_beneli_lvl")+"]^2  "+getcvar("scr_beneli_price")+level._str["money"]);
   
   
	self thread LookstatsPlayer();
	self thread ammocounter();
	self thread refreshhud();

	for(i=0;i<level.weaponnames.size;i++)
	{
		name=level.weaponnames[i];
		self.pers["haswep"+name]=0;
		if(level.weapons[name].price==0)
			self.pers["haswep"+name]=1;
	}

	[[level.callbackPlayerConnect]]();
	
	wait 1;
	for(i=0;i<level.weaponnames.size;i++)
		self setclientcvar(level.weaponnames[i]+"_price",level.weapons[level.weaponnames[i]].price);
	wait 1;
	for(i=0;i<level.weaponnames.size;i++)
		self setclientcvar(level.weaponnames[i]+"_lvl",level.weapons[level.weaponnames[i]].lvl);
}
dowep(wep)
{
	if(wep=="none") return;
	if(!self hasweapon(wep))
		self setweaponslotweapon("primary",wep);
	self switchtoweapon(wep);
}
ammocounter()
{
	self endon("disconnect");
	wait 0.05;
	self waittill("spawned_player");
	self.ammox=-90;
	self.ammoy=-21;

	self.hud_clipammo = newClientHudElem(self);
	self.hud_clipammo.horzalign = "right";
	self.hud_clipammo.vertalign = "bottom";
	self.hud_clipammo.alignx = "right";
	self.hud_clipammo.aligny = "bottom";
	self.hud_clipammo.x = self.ammox;
	self.hud_clipammo.y = self.ammoy;
	self.hud_clipammo.fontScale = 2;
	self.hud_clipammo.label = &"";

	self.hud_reserveammo = newClientHudElem(self);
	self.hud_reserveammo.horzalign = "right";
	self.hud_reserveammo.vertalign = "bottom";
	self.hud_reserveammo.alignx = "left";
	self.hud_reserveammo.aligny = "bottom";
	self.hud_reserveammo.x = self.ammox;
	self.hud_reserveammo.y = self.ammoy+6;
	self.hud_reserveammo.fontScale = 2;
	self.hud_reserveammo.label = level._lstr["/"];

	self.currslot="primary";
	wait .1;
	self.oldwep = self getcurrentweapon();
	weapon = self getcurrentweapon();
	for(;;)
	{
		weapon = self getcurrentweapon();
		if(weapon != self.oldwep)
		{
			self.oldwep = weapon;
			if(weapon==self getweaponslotweapon("primary"))
				self.currslot="primary";
			else self.currslot="primaryb";
		}
		if(weapon!="flamethrower_mp" && weapon!="zomcolt_mp" && weapon!=level.sprint_weap) {
			self.hud_clipammo setValue(self getWeaponSlotClipAmmo(self.currslot, self getcurrentweapon()));
			self.hud_reserveammo.label=level._lstr["/"];
		}
		else {
			self.hud_clipammo settext(&"");
			self.hud_reserveammo.label=&"";
		}
		self.hud_reserveammo setValue(self getWeaponSlotAmmo(self.currslot, self getcurrentweapon()));
		
		if( weapon =="zumbi_mp" && self.pers["team"]=="axis" && self.zumbixp==0)
		self.zumbixp=1;else self.zumbixp=0;
		
		wait 0.1;
	}
}
PlayerDisconnect()
{
	self thread ER_zumbis\_login::save();
	
	if(isdefined(self.dbubble))self.dbubble delete();
	if(isdefined(self.bolhalove))self.bolhalove delete();
	if(isdefined(self.turret_bip))self.turret_bip delete();
    if(isdefined(self.turret_gun))self.turret_gun delete();
	if(isdefined(self.protmodel ))self.protmodel delete();
	
	[[level.callbackPlayerDisconnect]]();
	wait 2;
	if(level.lastman)
		thread checkRestart();
}
PlayerDamage(eInflictor, attacker, dmg, iDFlags, MOD, sWeapon, vPoint, vDir, sHitLoc, timeOffset)
{
    if(isDefined(self.spawnprotected) && self.spawnprotected)return;
    if(isDefined(self.spawnprotecao) && self.spawnprotecao)return;
    if(isDefined(self.nabolha) && self.nabolha)return;
		
 if(isPlayer(attacker) && attacker.pers["team"] == "spectator")
{
if(sWeapon == "frag_grenade_american_mp" || sWeapon == "frag_grenade_british_mp" || sWeapon == "frag_grenade_russian_mp"  || sWeapon == "frag_grenade_german_mp")
        return;
}		
				
if(isPlayer(attacker) && self.pers["team"] == "allies" && attacker == self)
{
if(sWeapon == "frag_grenade_american_mp" || sWeapon == "frag_grenade_british_mp" || sWeapon == "frag_grenade_russian_mp"  || sWeapon == "myball_mp" || sWeapon == "ercrossbow_mp" || sWeapon == "erRocket_mp" || sWeapon == "er_tnt")
        return;
}
	if(self.sessionteam == "spectator")
		return;


	[[level.callbackPlayerDamage]](eInflictor, attacker, dmg, iDFlags, MOD, sWeapon, vPoint, vDir, sHitLoc, timeOffset);
}
PlayerKilled(eInflictor, attacker, iDamage, sMeansOfDeath, sWeapon, vDir, sHitLoc, psOffsetTime, deathAnimDuration)
{

	self endon("spawned");
	self notify("killed_player");

	if(self.sessionteam == "spectator")
		return;


	// If the player was killed by a head shot, let players know it was a head shot kill
	if(sHitLoc == "head" && sMeansOfDeath != "MOD_MELEE")
		sMeansOfDeath = "MOD_HEAD_SHOT";
		
		if(sMeansOfDeath == "MOD_MELEE")     {attacker.pers["totbash"]++;}
        if(sMeansOfDeath == "MOD_HEAD_SHOT") { attacker.pers["tothead"]++;}    


	// send out an obituary message to all clients about the kill
	obituary(self, attacker, sWeapon, sMeansOfDeath);

     if(self.r700uso==1){level.r700use--;self.r700uso=0;}
	 if(self.ak47uso==1){level.ak47use--;self.ak470uso=0;}
	 if(self.raygunuso==1){level.raygunuse--;self.raygunuso=0;}
	 if(self.teslauso==1){level.teslause--;self.teslauso=0;}
     if(self.crossuso==1){level.crossuse=0;self.crossuso=0;}
     if(self.rocketuso==1){level.rocketuse=0;self.rocketuso=0;}
	 if(self.miniuso==1){level.miniuse--;self.miniuso=0;}
	 if(self.facauso==1){level.facause--;self.facauso=0;}
	 if(self.beneliuso==1){level.beneliuse--;self.beneliuso=0;}
     
	self.pers["totdeaths"]++;
	if(randomint(350)<level.dropitens && self.pers["team"]=="axis" && level.doublep !=1 && level.spawned_m!=1)
	{
	self thread spawnitem();
	}
	self thread destroyhud();
	if(isplayer(attacker) && attacker!=self)
	{	
        if(isDefined(attacker.pers["team"]=="allies" && level.doublep==1))	
		attacker thread givemoney(attacker thread getmoneydouble(sMeansOfDeath));
		else 
		attacker thread givemoney(attacker thread getmoney(sMeansOfDeath));
	
		
		attacker thread ER_zumbis\_ranks::xpup(sMeansOfDeath);attacker PlayLocalSound("thriller");
		if(attacker.pers["team"]=="allies"){attacker.streak++;attacker thread checkStreak();checklasthunter();}		
		attacker.pers["totkills"]++;		
		if(isDefined(attacker.killcount)){attacker.killcount++;}		
		if(isNade(sWeapon)){attacker.pers["totnade"]++;} 
		
	}
	self.streak=0;
	[[level.callbackPlayerKilled]](eInflictor, attacker, iDamage, sMeansOfDeath, sWeapon, vDir, sHitLoc, psOffsetTime, deathAnimDuration);
}
checklasthunter()
{  	
	if(playersonteam("allies")!=1 || isdefined(level.lasthunter)) return;
	players=getentarray("player","classname");
	for(i=0;i<players.size;i++)
	{
		if(players[i].pers["team"]!="allies" || !isalive(players[i])) continue;
		level.lasthunter=players[i];
		break;
	}
	players[i] iprintlnbold(&"ER_LASTHUNTER");
	players[i].dmgmult=2.4;
	players[i] thread takehunterweap();

}
takehunterweap()
{
    weapon = "myball_mp";
    sweapon = self getweaponslotweapon("primaryb");
    self takeWeapon(sweapon);
    self setWeaponSlotWeapon("primaryb", weapon);
    self giveMaxAmmo(weapon);
    self setSpawnWeapon(weapon);
	self playlocalsound("ultimohunter");
}

isNade( weapon )
{
	switch( weapon )
	{
	case "frag_grenade_american_mp":case "frag_grenade_british_mp":case "frag_grenade_russian_mp":case "frag_grenade_german_mp":return true;default:return false;
	}
}
getmoney(means)
{

	switch(means)
	{
	case "MOD_MELEE":
	if(!self.pers["isadmin"])
		return (getcvarint("sv_moneyfor_melee_kill")); 
		else return (getcvarint("sv_adm_moneyfor_melee_kill"));
		
	case "MOD_HEAD_SHOT":
	if(!self.pers["isadmin"])
     return (getcvarint("sv_moneyfor_head_kill"));
	 else return (getcvarint("sv_adm_moneyfor_head_kill"));

	 
	case "MOD_PISTOL_BULLET":
	default:
	
	case "MOD_RIFLE_BULLET":
	if(!self.pers["isadmin"])
		return (getcvarint("sv_moneyfor_kill"));
		else return (getcvarint("sv_adm_moneyfor_kill"));
	}
}
getmoneydouble(means)
{
	switch(means)
	{
	case "MOD_MELEE":
	if(!self.pers["isadmin"])return (getcvarint("sv_moneyfor_melee_kill")*2);
	else return (getcvarint("sv_adm_moneyfor_melee_kill")*2);
		
	case "MOD_HEAD_SHOT":
	if(!self.pers["isadmin"]) return (getcvarint("sv_moneyfor_head_kill")*2);
	else return (getcvarint("sv_adm_moneyfor_head_kill")*2);

	 
	case "MOD_PISTOL_BULLET":
	
	default:
	
	case "MOD_RIFLE_BULLET":
	if(!self.pers["isadmin"])return (getcvarint("sv_moneyfor_kill")*2);
	else return (getcvarint("sv_adm_moneyfor_kill")*2);
	}
}
checkStreak()
{

	if(isDefined(self.hud_monsterkill))self.hud_monsterkill destroy();
	self.hud_monsterkill = newClientHudElem(self);
	self.hud_monsterkill.x = 280;
	self.hud_monsterkill.y = 390;
	self.hud_monsterkill.alpha = 0.50;

	strk=self.streak;
	switch(strk)
	{
	case 3:
        self PlayLocalSound("triplekill");
		self.hud_monsterkill setShader("x2_triplekill", 100, 100);
		break;
	case 5:
		self.hud_monsterkill setShader("x2_multikill", 100, 100);
		self PlayLocalSound("multikill");
		if(isDefined(level.doublep))self thread givexp(1000);else self thread givexp(500);
		break;
	case 9:
		self PlayLocalSound("ultrakill");
		self.hud_monsterkill setShader("x2_ultrakill", 100, 100);
		if(isDefined(level.doublep))self thread givexp(1600);else self thread givexp(800);
		nade = self getnadetype("frag");
		nades=self getammocount(nade);
		self playLocalSound("grenade_pickup");
		self setWeaponClipAmmo(nade,nades+1);
		break;
	case 15:
		self PlayLocalSound("megakill");
		self.hud_monsterkill setShader("x2_megakill", 100, 100);
		if(isDefined(level.doublep))self thread givexp(2000);else self thread givexp(1000);
		break;
	case 20:
		self PlayLocalSound("monsterkill");
		self.hud_monsterkill setShader("x2_monsterkill", 100, 100);
		iprintlnbold(&"ER_MOM_MOM",self );
		if(isDefined(level.doublep))self thread givexp(3000);else self thread givexp(1500);
		nade = self getnadetype("frag");
		nades=self getammocount(nade);
		self playLocalSound("grenade_pickup");
		self setWeaponClipAmmo(nade,nades+2);
		self.pers["totmons"]++;
		break;
	case 25:
	    self.hud_monsterkill.x = 300;
		self.hud_monsterkill setShader("nuke_kill", 50, 50);		
		self thread ER_zumbis\_loja::nuke();
		break;
	}
}

// give self money
givemoney(money)
{
self notify("novi_money");
self.moneytoshow+=money;
self.pers["money"]+=money;
self endon("disconnect");
self endon("killed_player");
self endon("novi_money");
 		

 if (isDefined(self.money_hud_fade))self.money_hud_fade destroy();
 
 self.money_hud_fade = newClientHudElem(self);
 self.money_hud_fade.alignX = "center";
 self.money_hud_fade.alignY = "middle";
 self.money_hud_fade.x = 320;
 self.money_hud_fade.y = 215;
 self.money_hud_fade.fontscale = 0.8;
 self.money_hud_fade.alpha = 0;
 self.money_hud_fade fadeOverTime(1);
 self.money_hud_fade.alpha = 1;
 self.money_hud_fade.color = (1,230/255,125/255);
 
if(self.moneytoshow==0)
return;
if(self.moneytoshow>0)
self.money_hud_fade.label = &"ER_MAISRS";
else
self.money_hud_fade.color = (235/255,10/255,10/255);
self.money_hud_fade.label = &"ER_MENOSRS";
self.money_hud_fade setValue(self.moneytoshow);
 wait 0.5;
 self.money_hud_fade.alpha=1;
 for(i=1;i<=5;i++) 
 {
 wait .05;
 self.money_hud_fade.fontscale=0.7+i*0.20;
 }
 self.money_hud_fade fadeOverTime(1);
 wait 0.5;
 self.moneytoshow=0;
 self.money_hud_fade.alpha = 0;
 if (isDefined(self.money_hud_fade))self.money_hud_fade destroy();
 if(isDefined(self.hud_monsterkill))self.hud_monsterkill destroy();
	
}
// give self xp
givexp(xp)
{
	if(xp<=0) return;
	self.pers["xp"]+=xp;
	self ER_zumbis\_ranks::checkRank();
}
spawnPlayer()
{

    if(isDefined(self.money_hud_fade))self.money_hud_fade destroy();
	if (isDefined(self.xp_hud_fade))self.xp_hud_fade destroy();
	
	if(!isdefined(self.pers["weapon"]) || !self.pers["loggedin"]) return;
	self endon("disconnect");
	self.delayed = false;
	self.dmgmult=1.0;
	if (!isdefined(self.killcount))
		self.killcount=0;

	if (self.killcount > (getcvarint("scr_zom_returnkills") - 1))
		self.killcount = 0;

	self.maxhealth = getcvarint("scr_zom_"+self.pers["team"]+"Health");
	self.maxspeed = getcvarint("scr_zom_"+self.pers["team"]+"Speed");
	if(self.pers["team"] == "axis")
	{
		self iprintlnbold(&"ZOM_YOU_ARE_A_ZOMBIE");
		if(level.lastman)
		{
			num=playersonteam("axis");
			if(num<=1)
				self.maxhealth = getcvarint("scr_zom_axisHealth")*getcvarint("scr_zom_healthMultiplier");
			else
			{
				if(randomint(200)<level.superzomchance)
					self superzom();
			}
			self iprintlnbold(&"ZOM_KILL_THE_HUNTERS");
			self setClientCvar("cg_objectiveText", &"ZOM_YOU_ARE_A_ZOMBIE", &"ZOM_KILL_THE_HUNTERS", &"ZOM_OBJ_LMS", &"ZOM_OBJ_LMS_ALLIES");
		}
		else if(self.killcount == 0)
		{
			self iprintlnbold(&"ZOM_KILL_X_HUNTERS",0,getcvarint("scr_zom_returnkills"));
			self setClientCvar("cg_objectiveText", &"ZOM_YOU_ARE_A_ZOMBIE", &"ZOM_KILL_X_HUNTERS", getcvarint("scr_zom_returnkills"));
		}

	}
	else if(self.pers["team"] == "allies")
	{

		self makeobjmarker();

		mess0 = "";
		mess1 = "";

		self iprintlnbold(&"ZOM_YOU_ARE_A_HUNTER");



		if(getcvarint("scr_zom_alliesPointsForKilling")>1)
		{
			self iprintlnbold(&"ZOM_KILL_ZOMBIES");
			mess1 = &"ZOM_KILL_ZOMBIES";
		}

		self setClientCvar("cg_objectiveText", &"ZOM_YOU_ARE_A_HUNTER", mess0, mess1 );
	}

	self GiveWeapons();
	self.health = self.maxhealth;

	self.currslot="primaryb";
	if(level.lastman)
	thread checkRestart();
	thread hudelements();

	self.spawnprotected=0;

	wait 3;
	
	 
	if(!isalive(self) && isdefined(self.respawntext))
		self.respawntext destroy();
}
superzom()
{
self endon("spawned");
 iprintlnbold(&"ER_SUPERZOM",self);
 self.maxhealth = self.maxhealth *2;
 self.dmgmult=1.4;
 self thread ER_zumbis\_loja::healthRegen();
 playfx(level._fx["ion2"],self.origin);
self playSound("zumbi_spawn");
 }
nospawn()
{
	self endon("disconnect");
	self endon("spawned_player");
	wait 10;
	self notify("menuresponse","weapon_hunters","mp44_mp");
}
isclose(range)
{
	players = getentarray("player","classname");
	for(i=0;i<players.size;i++)
	{
		if(players[i]==self || players[i].pers["team"] == self.pers["team"])
			continue;
		if(distance(self.origin, players[i].origin)<=range)
			return 1;
	}
	return 0;
}

GiveWeapons()
{
	if(GetCvar("scr_zom_" + self.pers["team"] + "Pistol")=="1" || GetCvar("scr_zom_" + self.pers["team"] + "Pistol")=="2")
	{
		//self maps\mp\gametypes\_weapons::givePistol();
		self takeWeapon("colt_mp");
		self takeWeapon("webley_mp");
		self takeWeapon("TT30_mp");
		self takeWeapon("luger_mp");
		self takeWeapon("deagle_mp");

		//self giveWeapon(pistoltype);
		self setWeaponSlotWeapon("primaryb", "deagle_mp");
		self giveMaxAmmo("deagle_mp");

		if (GetCvar("scr_zom_" + self.pers["team"] + "Pistol")=="2")
			self setSpawnWeapon(self getweaponslotweapon("primaryb"));
	}

	if(!(GetCvar("scr_zom_" + self.pers["team"] + "Pistol")=="2"))
	{
		//self giveWeapon(self.pers["weapon"]);
		self setWeaponSlotWeapon("primary", self.pers["weapon"]);
		self setSpawnWeapon(self.pers["weapon"]);
		self giveMaxAmmo(self getweaponslotweapon("primary"));
	}
	if(GetCvar("scr_zom_" + self.pers["team"] + "MeleeOnly")=="1")
	{
		self setWeaponSlotAmmo( "primary", 0 );
		self setWeaponSlotClipAmmo( "primary", 0 );

		self setWeaponSlotAmmo( "primaryb", 0 );
		self setWeaponSlotClipAmmo( "primaryb", 0 );
	}

	if(GetCvar("scr_zom_" + self.pers["team"] + "OverrideNades")=="1")
	{
		frag=getcvarint("scr_zom_" + self.pers["team"] + "Nades");
		smoke=getcvarint("scr_zom_" + self.pers["team"] + "Smoke");

		self GiveNades(frag,smoke);
	}
	else
	{
		self GiveNades(-1,-1);
	}

	self giveWeapon("binoculars_mp");
}

GiveNades(frag,smoke)
{
	if(frag==-1) frag=maps\mp\gametypes\_weapons::getWeaponBasedGrenadeCount(self.pers["weapon"]);
	if(smoke==-1) frag=maps\mp\gametypes\_weapons::getWeaponBasedSmokeGrenadeCount(self.pers["weapon"]);
	grenadetype = self getnadetype("frag");
	smokegrenadetype = self getnadetype("smoke");

	self takeWeapon("frag_grenade_american_mp");
	self takeWeapon("frag_grenade_british_mp");
	self takeWeapon("frag_grenade_russian_mp");
	self takeWeapon("frag_grenade_german_mp");
	self takeWeapon("smoke_grenade_american_mp");
	self takeWeapon("smoke_grenade_british_mp");
	self takeWeapon("smoke_grenade_russian_mp");
	self takeWeapon("smoke_grenade_german_mp");

	// if(frag)
	// {
		self giveWeapon(grenadetype);
		self setWeaponClipAmmo(grenadetype, frag);
	// }
	if(smoke)
	{
		self giveWeapon(smokegrenadetype);
		self setWeaponClipAmmo(smokegrenadetype, smoke);
	}
	self switchtooffhand(grenadetype);
}

makeobjmarker()
{
	level.showoncompass = GetCvarInt("scr_zom_showoncompass");
	level.showasobjpoint = GetCvarInt("scr_zom_showasobjpoint");

	if (level.showasobjpoint)
	{
		temp = self.origin+(0,0,70);

		maps\mp\gametypes\_objpoints::addTeamObjpoint(temp, self.clientid, "axis", "objective");
	}

	if(level.showoncompass)
	{
		objnum = GetNextObjNum();
		if(objnum!=-1)
		{
			self.objnum = objnum;
			objective_add(objnum, "current", self.origin, "objective");
			objective_icon(objnum,"objective");
			objective_team(objnum,"axis");
			objective_position(objnum, self.origin);
			lastobjpos = self.origin;
			newobjpos = self.origin;
		}
	}


	if (level.showasobjpoint || level.showoncompass)
	{
		self thread DeleteOnEvent("killed_player");
		self thread DeleteOnEvent("disconnect");
		self thread updateobjmarker();
	}
}


updateobjmarker()
{
	self endon("StopOnCompass");


	level.positiontime = GetCvarInt("scr_zom_positiontime");

	if(level.positiontime<=0 || level.positiontime>20)
		level.positiontime=0.05;

	for(;;)
	{
		wait level.positiontime;

		if(level.showasobjpoint)
		{

			for(i = 0; i < level.objpoints_axis.array.size; i++)
			{
				if(level.objpoints_axis.array[i].name==self.clientid)
				{
					level.objpoints_axis.array[i].x=self.origin[0];
					level.objpoints_axis.array[i].y=self.origin[1];
					level.objpoints_axis.array[i].z=self.origin[2]+70;
				}
			}

			//maps\mp\gametypes\_objpoints::updatePlayerObjpoints();
			updateAllPlayerObjpoints("axis");
		}

		if(level.showoncompass)
		{
			objective_position(self.objnum, self.origin);
		}
	}
}

updateAllPlayerObjpoints(team)
{
	players = getentarray("player", "classname");
	for(i = 0; i < players.size; i++)
	{
		player = players[i];

		if(isDefined(player.pers["team"]) && player.pers["team"] == team) // && player.sessionstate == "playing"
			player maps\mp\gametypes\_objpoints::updatePlayerObjpoints();
	}
}

blackScreen(option)
{
blackScreenDelete();

	self.blackscreentext = newClientHudElem(self);
	self.blackscreentext.sort = -1;
	self.blackscreentext.archived = false;
	self.blackscreentext.alignX = "center";
	self.blackscreentext.alignY = "middle";
	self.blackscreentext.fontscale = 2.5;
	self.blackscreentext.x = 320;
	self.blackscreentext.y = 220;
	self.blackscreentext.alpha = 0;
	
	if (isDefined(option))
	{
		switch(option)
		{
		case "killed":
			self.blackscreentext settext(&"ZOM_YOU_WERE_KILLED_BY_A_ZOMBIE");
			break;
		case "return":
			self.blackscreentext settext(&"ZOM_YOU_KILLED_X_ZOMBIE_KILLERS");
			break;
		case "alliedTK":
			self.blackscreentext settext(&"ZOM_YOU_KILLED_A_TEAMMATE");
			break;
		case "axisTK":
			self.blackscreentext settext(&"ZOM_YOU_KILLED_A_TEAMMATE_AXIS");
			break;
		case "alliedSuicide":
			self.blackscreentext settext(&"ZOM_YOU_KILLED_YOURSELF");
			break;
		case "axisSuicide":
			self.blackscreentext settext(&"ZOM_YOU_KILLED_YOURSELF_AXIS");
			break;


		}
	}
	
	self.blackscreentext fadeOverTime(2.5);
	self.blackscreentext.alpha = 1;
	

	self.blackscreen = newClientHudElem(self);
	self.blackscreen.sort = -2;
	self.blackscreen.archived = false;
	self.blackscreen.alignX = "left";
	self.blackscreen.alignY = "top";
	self.blackscreen.x = 0;
	self.blackscreen.y = 0;
	self.blackscreen.alpha = 0;
	self.blackscreen setShader("black", 640, 480);
	self.blackscreen fadeOverTime(2);
	self.blackscreen.alpha = 1;
	
	if (option=="alliedTK" || option=="axisTK" || option=="alliedSuicide" || option=="axisSuicide")
	{
		self.blackscreentimer = newClientHudElem(self);
		self.blackscreentimer.sort = -1;
		self.blackscreentimer.archived = false;
		self.blackscreentimer.alignX = "center";
		self.blackscreentimer.alignY = "middle";
		self.blackscreentimer.x = 320;
		self.blackscreentimer.y = 260;
		self.blackscreentimer settimer(GetCvarInt("scr_zom_tktimeout"));
	}



	self thread blackScreenAutoDelete();

}

blackScreenAutoDelete()
{
	self waittill("spawned");

	if(isDefined(self))
	{
		if(isDefined(self.blackscreen))
			self.blackscreen destroy();

		if(isDefined(self.blackscreentext))
			self.blackscreentext destroy();

		if(isDefined(self.blackscreentimer))
			self.blackscreentimer destroy();
	}
}

blackScreenDelete()
{
	if(isDefined(self))
	{
		if(isDefined(self.blackscreen))
			self.blackscreen destroy();

		if(isDefined(self.blackscreentext))
			self.blackscreentext destroy();

		if(isDefined(self.blackscreentimer))
			self.blackscreentimer destroy();
	}
}

DeleteOnEvent(event)
{
	self waittill(event);

	self notify("StopOnCompass");
	if(isdefined (self.objnum))
	{
		objective_delete(self.objnum);
		level.objused[(self.objnum)] = false;
		self.objnum = undefined;
	}

	if(level.showasobjpoint==1)
	{
		for(i = 0; i < level.objpoints_axis.array.size; i++)
		{
			if(level.objpoints_axis.array[i].name==self.clientid)
			{
				level.objpoints_axis.array[i].name=undefined;

				clearHudObjPoints("axis");
				cleanObjPointsArray();
				updateAllPlayerObjpoints("axis");
			}
		}
	}
}

cleanObjPointsArray()
{
	// Rebuild objpoints array minus named
	cleanpoints = [];
	for(i = 0; i < level.objpoints_axis.array.size; i++)
	{
		objpoint = level.objpoints_axis.array[i];

		if(isdefined(objpoint.name))
			cleanpoints[cleanpoints.size] = objpoint;
	}
	//return cleanpoints;
	level.objpoints_axis.array=cleanpoints;
}

clearHudObjPoints(team)
{
	players = getentarray("player", "classname");
	for(i = 0; i < players.size; i++)
	{
		player = players[i];

		if(isDefined(player.pers["team"]) && player.pers["team"] == team) // && player.sessionstate == "playing"
			player maps\mp\gametypes\_objpoints::clearPlayerObjpoints();
	}
}

GetNextObjNum()
{
	for (i=0;i<15;i++)
	{
		if(level.objused[i])
			continue;

		level.objused[i] = true;
		return i;
	}
	return -1;
}

checkRestart(zombie)
{
	numonteam = playersonteam("both");
	players = getentarray("player","classname");

	//No Allied so restart...
	if(numonteam["allies"] == 0 && numonteam["axis"]>1)
	{
		level.lasthunter=undefined;
		//Select a zombie
		if(isDefined(zombie) && isPlayer(zombie) && !getcvarint("scr_zom_randomZombie"))
			axisPlayer = zombie;
		else
		{
			axisPlayer = players[randomint(players.size)];
		}
   
		level.campkilltimeleft = level.camperkilltime;
		setexpfog(0.00001,0,0,0,5);	
		level notify("round_restarte");
		level notify("finish_double");
		self notify("destroi_huddouble");
		if(isDefined(level.doublep))level.doublep="";		
		if(isDefined(self.hud_double))self.hud_double destroy();
		if(getcvarint("sv_ambient_soundOFF"=="1"))
		ambientStop(0);
                /*self.bolha==0;
                self.sentry==0;
                self.mg42==0;*/

		for(i = 0; i < players.size; i++)
		{
			player = players[i];

			if(!player.pers["loggedin"])
				continue;

			
			if(isdefined(self.hud_nuketimer))self.hud_nuketimer destroy();

			//clientAnnouncement(player, "^1Round Restart");
			player iprintlnbold(&"ZOM_ROUND_RESTART");
			level.dogMP=0;
			

			if(player == axisPlayer)
			{
				//clientAnnouncement(player, "You are the new zombie!");
				player iprintlnbold(&"ZOM_YOU_ARE_THE_NEW_ZOMBIE");

				player thread movePlayer("axis", 2);
				// player [[level.axis]]();
			}
			else
				player thread movePlayer("allies", 4);
				// player [[level.allies]]();
		}
		return true;
	}
	else
		return false;
}

movePlayer(team, delay)
{
	self endon("disconnect");
	if(isDefined(self.respawntext))
		self.respawntext destroy();
	if(self.pers["team"]=="spectator")
		return;

	if(self.sessionstate == "playing")
	{
		// Set a flag on the player to they aren't robbed points for dying - the callback will remove the flag
		self.switching_teams = true;
		self.joining_team = team;
		self.leaving_team = self.pers["team"];
		self suicide();
	}

	if(self.pers["team"] != team)
	{
		self.pers["team"] = team;
		self.pers["weapon"] = undefined;
		self.pers["weapon1"] = undefined;
		self.pers["weapon2"] = undefined;
		self.pers["spawnweapon"] = undefined;
		self.pers["savedmodel"] = undefined;
		ShowWeapons = true;
	}
	else
	{
		ShowWeapons = false;
	}

	self.sessionteam = self.pers["team"];
	// update spectator permissions immediately on change of team
	self maps\mp\gametypes\_spectating::setSpectatePermissions();


	self.delayed=true;

	wait delay;

	self.delayed=false;

	self blackScreenDelete();

	self closemenu();
	self closeingamemenu();
	if(ShowWeapons)
	{
		self setClientCvar("ui_allow_weaponchange", "1");

		if(self.pers["team"] == "allies")
		{
			self setClientCvar("g_scriptMainMenu", game["menu_weapon_allies"]);
			self openMenu(game["menu_weapon_allies"]);
			self thread nospawn();
		}
		else
		{
			self setClientCvar("g_scriptMainMenu", game["menu_weapon_axis"]);
			self openMenu(game["menu_weapon_axis"]);
		}
	}

	self maps\mp\gametypes\_teams::updateTeamTime();

	self notify("joined_team");
	self notify("end_respawn");

	self thread maps\mp\gametypes\zom::respawn();
}
doexplosion(ent)
{
	playfx(level._fx["explode"],ent.origin);
	ent playsound("rocket_explode_sand");
	raddmg(ent.origin, 136, 140, 50, self);
}
noitesombria()
{

  level endon("round_restarte");
  
 players = getEntArray( "player", "classname" );
 for( i = 0; i < players.size; i++ ) 
 {
        player = players[i];		
		player Playlocalsound("startnoite");	
		setexpfog(0.005,0.1,0,0,5);	
         wait (getcvarint("sv_night_time"));
		 player Playlocalsound("byenoite"); 
			
}
setexpfog(0.00001,0,0,0,5);
}
TimeToEnd()
{
level endon("stop_now");
players = getentarray("player", "classname");
timetoend = level.timelimit;
setCvar("sv_hostname", level.servername +"^7Next map in: ^330 ^7Min!");

	while(1)
	{
	wait 60;
	timetoend = timetoend - 1;
	setCvar("sv_hostname", level.servername +"^7Next map in: ^3" + timetoend + " ^7Min!");
			
	}
}

announceSound (sound, delay)
{
	self endon ("disconnect");

	while (isdefined (self.announceSound_running))
		wait 0.1;
	
	self.announceSound_running = true;
	
	self playLocalSound (sound);
	wait delay;

	self.announceSound_running = undefined;
}

checkCountdown()
{

	level.campkilltimeleft = level.camperkilltime;
	
	level.hud_camptxt = newHudElem();
	level.hud_camptxt.x = 6;
	level.hud_camptxt.y = 2;
	level.hud_camptxt.fontScale = 0.8;
	level.hud_camptxt.label = &"ER_HUNTERSTIME";

	while ((! isdefined (level.mapended)) || (! level.mapended))
	{
	
			_p = getentarray("player", "classname");

		if (getcvar("givemoney") == "all")
		{
			for (i = 0; i < _p.size; i++)
			{			  
			 _p[i] thread sq_money();
			}
			setcvar("givemoney", "");
		}
		if (getcvar("cash") != "")
		{
			for (i = 0; i < _p.size; i++)
			{
				if (getcvarint("cash") == _p[i] getEntityNumber())
					_p[i] thread sq_money();
			}
			setcvar("cash", "");
			
		}
		
		wait 1;

		if ((! isdefined (game["state"])) || (game["state"] != "playing"))continue;
		if ((! isdefined (level.timelimit)) || (level.timelimit <= 0))continue;

		seconds_left = int ((level.starttime + level.timelimit * 60 * 1000 - getTime () + 500) / 1000);
		
  switch (seconds_left)
  {case 1 :sound = seconds_left + "s";
  playfx(level._fx["nuke"],level.mapcenter);break;			
  case 2 :case 3 :case 4 :case 5 :case 6 :case 7 :case 8 :case 9 :case 10 :sound = seconds_left + "s";
  break;case 15 :case 20 :case 25 :sound = seconds_left + "s";break;default :sound = "";break;}
	
		if (sound != "")
		{
		
				players = getentarray ("player", "classname");
				for (i = 0; i < players.size; i ++)
					players[i] thread announceSound (sound, 0);
		}
		
			if(playersonteam("all") > 1)
	    level.campkilltimeleft--;
		
		if(level.campkilltimeleft <=0)
		{
			iprintlnbold(&"ER_HUNTERS_DEAD");
			level.campkilltimeleft = level.camperkilltime;
			
			players = getentarray("player","classname");
			for(i=0;i<players.size;i++)
			{
				if(players[i].pers["team"]=="allies")
					players[i] suicide();
					players[i].pers["totdeaths"]--;	
			}
			
		}
		else if(level.campkilltimeleft ==(getcvarint("sv_delay_night")))thread noitesombria();
		level.hud_camptxt setTimer(level.campkilltimeleft);
		
		
		}
		
	}

LookstatsPlayer()
{

while(isdefined(self))
{
trace=bullettrace(self geteye()+(0,0,20),self geteye()+(0,0,20)+maps\mp\_utility::vectorscale(anglestoforward(self getplayerangles()),99999),true,self);
if(isplayer(trace["entity"]) && trace["entity"].pers["team"]==self.pers["team"])
{
if(!isdefined(self.infolvl))
{
	self.infoIcon = newClientHudElem(self);
    self.infoIcon.alignx = "center";
    self.infoIcon.x = 310;
    self.infoIcon.y = 200; 
    self.infoIcon.sort = 0.5;
    self.infoIcon.alpha = 0.6;
    self.infoIcon setShader(level.patente_icon[int(trace["entity"].pers["lvl"])], 15, 15);

	/*self.infoname = newClientHudElem(self);
    self.infoname.x = 300;
    self.infoname.y = 200; 
	self.infoname.sort = 0.5;
    self.infoname.alpha = 0.6;
    self.infoname.fontscale = 0.8;
    self.infoname setPlayerNameString(trace["entity"]);*/
	
	self.infolvl = newClientHudElem(self);
    self.infolvl.x = 300;
    self.infolvl.y = 225; 
	self.infolvl.sort = 0.5;
    self.infolvl.alpha = 0.5;
    self.infolvl.fontscale = 0.8;
	self.infolvl.label = &"ER_LEVL";
	self.infolvl setValue(trace["entity"].pers["lvl"]);
	
	self.infomoney = newClientHudElem(self);
    self.infomoney .x = 300;
    self.infomoney .y = 238; 
	self.infomoney.sort = 0.5;
    self.infomoney.alpha = 0.4;
    self.infomoney .fontscale = 0.8;
	self.infomoney.label = &"ER_RS";
	self.infomoney setvalue(trace["entity"].pers["money"]);
	

}
else
{
//self.infoname setPlayerNameString(trace["entity"]);
self.infolvl setValue(trace["entity"].pers["lvl"]);
self.infomoney setvalue(trace["entity"].pers["money"]);
self.infoIcon setShader(level.patente_icon[int(trace["entity"].pers["lvl"])], 15, 15);
}
}
else if(!isplayer(trace["entity"]) && isdefined(self.infolvl))
{
//if(isdefined(self.infoname))self.infoname destroy();
if(isdefined(self.infolvl))self.infolvl destroy();
if(isdefined(self.infomoney))self.infomoney destroy();
if(isdefined(self.infoIcon))self.infoIcon destroy();
}
wait 0.1;
}
}
hudelements()
{
 
	self.statsx = -635;
	self.statsy = 60;
	self.ammox = -90;
	self.ammoy = -21;
	self.itemsx = -120;
	self.itemsy = 22;
	
	if(isDefined(self.hud_patenteicon))self.hud_patenteicon destroy();
	self.hud_patenteicon = newClientHudElem(self);
    self.hud_patenteicon.alignx = "center";
    self.hud_patenteicon.aligny = "middle";
    self.hud_patenteicon.x = 38;
    self.hud_patenteicon.y = 430; //401
    self.hud_patenteicon.archived = false;

	
	if(isDefined(self.xpbar1))self.xpbar1 destroy();
	self.xpbar1 = newClientHudElem(self);
	self.xpbar1.vertalign = "bottom";
	self.xpbar1.horzalign = "left";
	self.xpbar1.alignx = "left";
	self.xpbar1.aligny = "bottom";
	self.xpbar1.x = 320;
	self.xpbar1.y = -1;
	self.xpbar1.sort = 999;
	self.xpbar1.alpha = 1;
	self.xpbar1 setShader("ind", 320, 7);
	
	if(isDefined(self.xpbar2))self.xpbar2 destroy();
	self.xpbar2 = newClientHudElem(self);
	self.xpbar2.vertalign = "bottom";
	self.xpbar2.horzalign = "left";
	self.xpbar2.alignx = "left";
	self.xpbar2.aligny = "bottom";
	self.xpbar2.y = -1;
	self.xpbar2.sort = 999;
	self.xpbar2.alpha = 1;
	self.xpbar2 setShader("ind", 320, 7);
	
	if(isDefined(self.xpbar))self.xpbar destroy();
	self.xpbar = newClientHudElem(self);
	self.xpbar.vertalign = "bottom";
	self.xpbar.horzalign = "left";
	self.xpbar.alignx = "left";
	self.xpbar.aligny = "bottom";
	self.xpbar.y = -1;
	self.xpbar.alpha = 0.50;
	self.xpbar.color = (0.78, 0.78, 0.08);  
	if(isdefined(self.xpheight) && self.xpheight>0)
	self.xpbar setShader("white", self.xpheight, 5);

	self.xpnum destroy();	
	self.xpnum = newClientHudElem(self);
	self.xpnum.vertalign = "middle";
	self.xpnum.horzalign = "left";
	self.xpnum.alignx = "left";
	self.xpnum.aligny = "middle";
	self.xpnum.y = 230;
	self.xpnum.x = 2;
	self.xpnum.fontScale = .8;
	self.xpnum.color = (0,1,0);
	self.xpnum.label = &"ER_XP";
	self.xpnum setValue(self.pers["xp"]);

	self.xpnum2 destroy();
	self.xpnum2 = newClientHudElem(self);
	self.xpnum2.vertalign = "middle";
	self.xpnum2.horzalign = "left";
	self.xpnum2.alignx = "right";
	self.xpnum2.aligny = "middle";
	self.xpnum2.y = 230;
	self.xpnum2.x = 635;
	self.xpnum2.fontScale = .8;
	self.xpnum2.color = (0,1,0);
	self.xpnum2.label = &"ER_XPNEEDED";
	self.xpnum2 setValue(self.pers["xpneeded"]);

	self.hud_lvl destroy();
	self.hud_lvl = newClientHudElem(self);
	self.hud_lvl.vertalign = "middle";
	self.hud_lvl.horzalign = "left";
	self.hud_lvl.alignx = "left";
	self.hud_lvl.aligny = "middle";
	self.hud_lvl.y = 210;
	self.hud_lvl.x = 18;
	self.hud_lvl.fontScale = 1.2;
	self.hud_lvl.label = &"ER_LVL";
	self.hud_lvl setValue(self.pers["lvl"]);
	
	self.hud_life destroy();
	self.hud_life = newClientHudElem(self);
	self.hud_life.vertalign = "middle";
	self.hud_life.horzalign = "left";
	self.hud_life.alignx = "left";
	self.hud_life.aligny = "middle";
	self.hud_life.y = 110;
	self.hud_life.x = 550;
	self.hud_life.fontScale = 1.2;
	self.hud_life.label = &"ER_LIFE";
	self.hud_life setValue(self.maxhealth);

	self.hud_money destroy();
	self.hud_money = newClientHudElem(self);
	self.hud_money.alignx = "left";
	self.hud_money.horzalign = "right";
	self.hud_money.x = self.statsx+80;
	self.hud_money.y = self.itemsy +435;
	self.hud_money.fontScale = 1.0;
	self.hud_money.label = &"ER_DINHEIRO";
	
	self.hud_mosters destroy();
	self.hud_mosters = newClientHudElem(self);
	self.hud_mosters.alignx = "left";
	self.hud_mosters.horzalign = "right";
	self.hud_mosters.x = self.statsx;
	self.hud_mosters.y = self.itemsy-11;
	self.hud_mosters.fontScale = .8;
	self.hud_mosters.label = &"ER_MONSTERKILL";
	
	self.hud_totalkills destroy();
	self.hud_totalkills = newClientHudElem(self);
	self.hud_totalkills.alignx = "left";
	self.hud_totalkills.horzalign = "right";
	self.hud_totalkills.x = self.statsx;
	self.hud_totalkills.y = self.itemsy;
	self.hud_totalkills.fontScale = .8;
	self.hud_totalkills.label = &"ER_TOTKILLS";

	self.hud_totaldeaths destroy();
	self.hud_totaldeaths = newClientHudElem(self);
	self.hud_totaldeaths.alignx = "left";
	self.hud_totaldeaths.horzalign = "right";
	self.hud_totaldeaths.x = self.statsx;
	self.hud_totaldeaths.y = self.itemsy+11;
	self.hud_totaldeaths.fontScale = .8;
	self.hud_totaldeaths.label = &"ER_TOTDEATHS";

	self.hud_totalbashs destroy();
	self.hud_totalbashs = newClientHudElem(self);
	self.hud_totalbashs.alignx = "left";
	self.hud_totalbashs.horzalign = "right";
	self.hud_totalbashs.x = self.statsx;
	self.hud_totalbashs.y = self.itemsy+22;
	self.hud_totalbashs.fontScale = .8;
	self.hud_totalbashs.label = &"ER_TOTBASH";

	self.hud_totalheads destroy();
	self.hud_totalheads = newClientHudElem(self);
	self.hud_totalheads.alignx = "left";
	self.hud_totalheads.horzalign = "right";
	self.hud_totalheads.x = self.statsx;
	self.hud_totalheads.y = self.itemsy+33;
	self.hud_totalheads.fontScale = .8;
	self.hud_totalheads.label = &"ER_TOTHEADS";
	
	self.hud_totalnades destroy();
	self.hud_totalnades = newClientHudElem(self);
	self.hud_totalnades.alignx = "left";
	self.hud_totalnades.horzalign = "right";
	self.hud_totalnades.x = self.statsx;
	self.hud_totalnades.y = self.itemsy+44;
	self.hud_totalnades.fontScale = .8;
	self.hud_totalnades.label = &"ER_TOTNADES";
	
    self.hud_nuke destroy();
	self.hud_nuke = newClientHudElem(self);
	self.hud_nuke.alignx = "left";
	self.hud_nuke.horzalign = "right";
	self.hud_nuke.x = self.statsx;
	self.hud_nuke.y = self.itemsy+55;
	self.hud_nuke.fontScale = .8;
	self.hud_nuke.label = &"ER_NUKEKILLS";
	
}
refreshhud()
{
	self endon("disconnect");
		
	for(;;)
	{
		if(isDefined(self.hud_money))       self.hud_money setvalue(self.pers["money"]);	
		if(isDefined(self.hud_life))       self.hud_life setvalue(self.health);
		if(isDefined(self.hud_mosters))       self.hud_mosters setvalue(self.pers["totmons"]);
		if(isDefined(self.hud_totalkills))  self.hud_totalkills setvalue(self.pers["totkills"]);
		if(isDefined(self.hud_totaldeaths)) self.hud_totaldeaths setvalue(self.pers["totdeaths"]);
		if(isDefined(self.hud_nuke)) self.hud_nuke setvalue(self.pers["totnukes"]);
		
		if(isDefined(self.hud_totalbashs))  self.hud_totalbashs setvalue(self.pers["totbash"]);
		if(isDefined(self.hud_totalheads))   self.hud_totalheads setvalue(self.pers["tothead"]);
        if(isDefined(self.hud_totalnades))   self.hud_totalnades setvalue(self.pers["totnade"]);
		if(isdefined(self.xpbar) && isdefined(self.xpheight) && self.xpheight>0)self.xpbar setShader("white", self.xpheight, 5);
		if(isdefined(self.xpnum))  self.xpnum setValue(self.pers["xp"]);
		if(isdefined(self.xpnum2)) self.xpnum2 setValue(self.pers["xpneeded"]);
		if(isdefined(self.hud_lvl)) self.hud_lvl setValue(self.pers["lvl"]);
		if(self.pers["lvl"]==int(self.pers["lvl"]))self.hud_patenteicon setShader(level.patente_icon[int(self.pers["lvl"])], 20, 20);
		if(self.pers["lvl"]>100)self.hud_patenteicon setShader(level.patente_icon[100], 20, 20);
		if(self.pers["money"]>100000)self.pers["money"]=100000;
                if(self.pers["lvl"]>999)self.pers["lvl"]=999;
						


		wait 0.1;
	}
}
destroyhud()
{
	if(isDefined(self.hud_patenteicon))    self.hud_patenteicon destroy();
	if(isDefined(self.hud_money))          self.hud_money destroy();
	if(isDefined(self.hud_life))           self.hud_life destroy();
	if(isDefined(self.hud_mosters))           self.hud_mosters destroy();
	if(isDefined(self.hud_totalkills))     self.hud_totalkills destroy();
	if(isDefined(self.hud_totaldeaths))	   self.hud_totaldeaths destroy();
	if(isDefined(self.hud_nuke))	   self.hud_nuke destroy();
	

	if(isDefined(self.hud_totalbashs))     self.hud_totalbashs destroy();
	if(isDefined(self.hud_totalheads))      self.hud_totalheads destroy();
	if(isDefined(self.hud_totalnades))      self.hud_totalnades destroy();

	if(isdefined(self.xpbar))              self.xpbar destroy();
	if(isdefined(self.xpbar1))              self.xpbar1 destroy();
	if(isdefined(self.xpbar2))              self.xpbar2 destroy();
	if(isdefined(self.hud_lvl))            self.hud_lvl destroy();
	if(isdefined(self.xpnum))              self.xpnum destroy();
	if(isdefined(self.xpnum2))             self.xpnum2 destroy();
	
	if(isDefined(self.money_hud_fade))    self.money_hud_fade destroy();
}
spawnitem()
{
    level.spawned_m=1;
	model=spawn("script_model",self.origin);
    model setmodel("xmodel/hoek_2x");
	model rotateyaw(1800000,10000);
	model thread timeout(model);
	model endon("timeout");
	
    players=getentarray("player","classname");
	while(isDefined(model))
	{
     
		for(i=0;i<players.size;i++)
		{
		if( distance( model.origin, players[i].origin ) < 50 && players[i].pers["team"]=="allies" && isAlive(players[i])) 
		{
	    players[i] playsound("risada");
		
		if(players[i].pers["team"]=="allies")
         {
		players[i] iprintlnbold(&"ER_DBS");
		players[i] playlocalsound("dobropontos");
		players[i] thread doubleStart();
		 }
	   
	   level.doublep=1;
	   thread doubletime();
	   self notify("done");
       model delete();	
	   level.spawned_m="";
       		
		 }
         }
    wait 0.05;
    }
}
doubletime()
{
level notify("finish_double");
level endon("finish_double");
wait 60;
players=getentarray("player","classname");
for(i=0;i<players.size;i++)
{
if(players[i].pers["team"]=="allies")
{
players[i] iprintlnbold(&"ER_DBP");
players[i] playlocalsound("hahabyebye");
}
if(isDefined(players[i].hud_double))players[i].hud_double destroy();
players[i] notify("destroy_huddouble");
}

level.doublep="";
}
doubleStart()
{
    self endon("disconnect");
	self endon("destroi_huddouble");
	if(isDefined(self.hud_double))
	self.hud_double destroy();
	self.hud_double = newClienthudelem(self);
	self.hud_double.alignx = "center";
	self.hud_double.aligny = "middle";
	self.hud_double.x = 580;
	self.hud_double.y = 200;
	self.hud_double.fontScale = 1;
	self.hud_double.label = &"ER_DOUBLEX";
	self.hud_double.color = (0,1,0);
	self.hud_double settimer(60);

	for(i=0;i<60;i++) 
	{			
    if( self.pers["team"] != "allies" || !isDefined(level.doublep) )
	if(isDefined(self.hud_double))self.hud_double destroy();
	self notify("destroi_huddouble");
	wait 0.5;
	}
	
    if(isDefined(self.hud_double))self.hud_double destroy();

}
timeout(m)
{
    self endon("done");

	for(i=0;i<60;i++) 
	{			
    playfx(level._effect["powerup2"], m.origin+(0, 0, 15));wait 0.5;
	}
	self notify("timeout");
	self delete();
	level.spawned_m="";
}
sq_money(){ 
if(self.pers["money"]>10000)
return;
self.script = "money";
self thread ER_zumbis\_ER::givemoney(1000);
self playlocalsound("paranossa");
self iprintlnbold(&"ER_PARANOSSA");
}
/*mito()
{

	level.nome destroy();
	level.nome = newHudElem();
	level.nome.x = 600;
	level.nome.y = 6; 
	level.nome.fontscale = 1.2;
	level.nome.label = &"ER_MITO";
		
	level.lvl destroy();
	level.lvl = newHudElem();
	level.lvl.x = 600;
	level.lvl.y = 20; 
	level.lvl.fontscale = 1.2;
	level.lvl.label = &"ER_LVL";
	
	level.matou destroy();
	level.matou = newHudElem();
	level.matou.x = 600;
	level.matou.y = 36; 
	level.matou.fontscale = 1.2;
	level.matou.label = &"ER_MATOU";
	
	level.morreu destroy();
	level.morreu = newHudElem();
	level.morreu.x = 600;
	level.morreu.y = 52; 
	level.morreu.fontscale = 1.2;
	level.morreu.label = &"ER_MORTES";
	
	level.head destroy();
	level.head = newHudElem();
	level.head.x = 600;
	level.head.y = 68; 
	level.head.fontscale = 1.2;
	level.head.label = &"ER_MATOU_DE_HEADSHOT";
	
	level.bash destroy();
	level.bash = newHudElem();
	level.bash.x = 600;
	level.bash.y = 82; 
	level.bash.fontscale = 1.2;
	level.bash.label = &"ER_MATOU_DE_BASH";
	
	level.monster destroy();
	level.monster = newHudElem();
	level.monster.x = 600;
	level.monster.y = 98; 
	level.monster.fontscale = 1.2;
	level.monster.label = &"ER_MOSTERKILLS";
	
	level.nukes destroy();
	level.nukes = newHudElem();
	level.nukes.x = 600;
	level.nukes.y = 114; 
	level.nukes.fontscale = 1.2;
	level.nukes.label = &"ER_NUKES";
	
	players = getentarray("player", "classname");
	
	highscore = undefined;
	tied = undefined;
	playername = undefined;
	name = undefined;
	guid = undefined;

	for(i = 0; i < players.size; i++)
	{
		player = players[i];

		if(isdefined(player.pers["team"]) && player.pers["team"] == "spectator")
			continue;
			
   player.pers["pontos"] = int(player.pers["totkills"] - player.pers["totdeaths"]);
   player.pers["bonus"] = int(player.pers["totbash"] + player.pers["tothead"] + player.pers["totnade"] + player.pers["totmons"] + player.pers["totnukes"] );
   player.pers["mito"] = int(player.pers["pontos"] + player.pers["bonus"]); 
	
		if(!isdefined(highscore))
		{
			highscore = player.pers["mito"];
			playername = player;
			name = player.name;
			guid = player getGuid();
			continue;
		}

		if(player.score == highscore)
			tied = true;
		else if(player.score > highscore)
		{
			tied = false;
			highscore = player.pers["mito"];
			playername = player;
			name = player.name;
			guid = player getGuid();
		}
	}

	players = getentarray("player", "classname");
	for(i = 0; i < players.size; i++)
	{
		player = players[i];

		if(isdefined(tied) && tied == true)
			player setClientCvar("cg_objectiveText", &"MP_THE_GAME_IS_A_TIE");
			
		else if(isdefined(playername))
		
			level.nome setPlayerNameString(playername);
			level.lvl setvalue(playername.pers["lvl"]);
			level.matou setvalue(playername.pers["totkills"]);
			level.morreu setvalue(playername.pers["totdeaths"]);
			level.head setvalue(playername.pers["tothead"]);
			level.bash setvalue(playername.pers["totbash"]);
			level.nade setvalue(playername.pers["totnade"]);
			level.monster setvalue(playername.pers["totmons"]);
			level.nukes setvalue(playername.pers["totnukes"]);
			
    }
	for(x=20; x > 1; x--)
    {

			level.nome.x -= 1;
			level.lvl.x -= 1;
			level.matou.x -= 1; 
			level.morreu.x -= 1; 
			level.head.x -= 1; 
			level.bash.x -= 1;
			level.nade.x -= 1;
			level.monster.x -= 1;
			level.nukes.x -= 1;
			
		wait 1;	
    } 
}	
*/