respond(response)
{
	if(!isdefined(response))
		return;
	if(response == "dologin")
	{
		self.pers["loginpart"] = 0;
		self setclientcvar("loginpart",0);
	}
	else if(response == "doregister")
	{
		self.pers["loginpart"] = 1;
		self setclientcvar("loginpart",1);
	}
	else if(response == "typeid")
	{
		self.pers["logintype"] = 0;
		self setclientcvar("logintype",0);
	}
	else if(response == "typepw")
	{
		self.pers["logintype"] = 1;
		self setclientcvar("logintype",1);
	}
	else if(response == "loginback")
	{
		if(self.pers["logintype"]==0)
		{
			str = getsubstr(self.pers["login"],0,self.pers["login"].size-1);
			self.pers["login"] = str;
			self setClientCvar("id", self.pers["login"]);
		}
		else if(self.pers["logintype"]==1)
		{
			str = getsubstr(self.pers["password"],0,self.pers["password"].size-1);
			self.pers["password"] = str;
			self setClientCvar("pass", self.pers["password"]);
		}
	}
	else if(response == "confirm")
	{
	if(self.pers["login"].size <4 && self.pers["loginpart"]==1 || self.pers["password"].size <4 && self.pers["loginpart"]==1)
	self thread noconfirm();
	else
	self thread confirm();
	}
	else if(response == "reset")
	{
		if(self.pers["logintype"]==0)
			self thread reset("id");
		else if(self.pers["logintype"]==1)
			self thread reset("pass");
	}
	else
		self thread addchar(response);
}
addchar(char)
{
	if(self.pers["logintype"]==0)
	{
	    if(self.pers["login"].size >7)return;
		self.pers["login"] += char;
		self setClientCvar("id", self.pers["login"]);
		
	}
	else if(self.pers["logintype"]==1)
	{
	    if(self.pers["password"].size >7)return;
		self.pers["password"] += char;
		self setClientCvar("pass", self.pers["password"]);
	}
}
addpass(char)
{
	self.templogin += char;
	self setClientCvar("pass", self.templogin);
}
noconfirm()
{
self iprintlnbold(&"ER_LOWCARACTER");
self reset("regpass");
self reset("regid");

wait 2;
self openMenu("login");
}
confirm()
{
	if(self.pers["loginpart"]==0)
	{
		self setClientCvar("pass", self.pers["password"]);
		a = self checklogin();
		if(a == 1)
		{
			self.pers["loggedin"]=1;
			self openMenu(game["menu_team"]);
		}
		else
		{
			self reset("id");
			self reset("pass");
		}
	}
	if(self.pers["loginpart"]==1)
	{
		self setClientCvar("pass", self.pers["password"]);
		a = self register();
		if(a == 1)
		{
			self.pers["loggedin"] = 1;
			self openMenu(game["menu_team"]);
		}
		else
		{
			self reset("regpass");
			self reset("regid");
		}
	}
}
reset(part)
{
	if(part == "id")
	{
		self.pers["login"] = "";
		self.templogin = "";
		self setClientCvar("id", "");
		self setClientCvar("g_scriptmainmenu", "login");
	}
	if(part == "pass")
	{
		self.pers["password"] = "";
		self.templogin = "";
		self setClientCvar("pass", "");
	}
	if(part == "regid")
	{
		self.pers["login"] = "";
		self.templogin = "";
		self setClientCvar("id", "");
		self setClientCvar("g_scriptmainmenu", "login");
	}
	if(part == "regpass")
	{
		self.pers["password"] = "";
		self.templogin = "";
		self setClientCvar("pass", "");
		self setClientCvar("g_scriptmainmenu", "login");
	}
}
checklogin()
{
	players=getentarray("player","classname");
	for(i=0;i<players.size;i++)
	{
		if(players[i]!=self && players[i].pers["loggedin"] && players[i].pers["login"] == self.pers["login"])
		{
			self iprintlnbold(&"ER_UM_PORACC");
			return -2;
		}
	}
	file = openFile(self.pers["login"] + ".mp3", "read");

	if(file == -1)
	{
		self.pers["loggedin"] = 0;
		self iprintlnbold(&"ER_INVALID_USER");
		
		self setClientCvar("g_scriptmainmenu", "login");
		CloseFile (file);
		return -1;
	}
	else
	{
		a = self load(file);
		CloseFile (file);
		return a;
	}
//	CloseFile (file);
}

register()
{
	if(self.pers["login"] == "")
	{
		self iprintlnbold(&"ER_EMPTY_USER");
		
		self setClientCvar("g_scriptmainmenu", "login");
		self.pers["login"] = "";
		self.pers["loggedin"] = 0;
		return -1;
	}
	else if(self.pers["password"] == "")
	{
		self iprintlnbold(&"ER_EMPTY_PW");
		self setClientCvar("g_scriptmainmenu", "login");
		self.pers["password"] = "";
		self.pers["loggedin"] = 0;
		return -1;
	}
	else
	{
		fname = self.pers["login"] + ".mp3";
		file = openFile(fname, "read");

		if(file == -1)
		{
			self.pers["loggedin"] = 1;
			self save();
			self setClientCvar("g_scriptmainmenu", game["menu_team"]);
			return 1;
		}
		else
		{
			CloseFile (file);
			self.pers["loggedin"] = 0;
			self iprintlnbold(&"ER_USERNAME_TAKEN");
			self setClientCvar("g_scriptmainmenu", "login");
			return -1;
		}
	}
	return -1;
}
load(file)
{
	for(;;)
	{
		elems = freadln (file);

		if (elems == -1)
			break;

		if (elems == 0)
			continue;

		line = "";
		for(pos = 0; pos < elems; pos ++)
		{
			line = line + fgetarg (file, pos);
			if (pos < elems - 1)
				line = line + ",";
		}

		if((getsubstr(line, 0, 2) == "//") || (getsubstr (line, 0, 1) == "#"))
			continue;

		array = strtok (line, " ,");

		pass = array[0];
		if(getsubstr(pass,0,2)=="_b")
		{
			n=int(getsubstr(pass,2,4));
			name=getsubstr(line,4,4+n);
			//iprintlnbold(pass+", "+n+", "+name);
			ER_zumbis\_ER_utils::printstr("banned",self,"\n^9(^7"+name+"^9)","bold");
			return 0;
		}

		arrsize=12;
		if(self.pers["password"] == pass)
		{
			if(array.size < arrsize)
			{
				for(i=array.size;i<arrsize;i++)
				{
					if(!isDefined(array[i]))
					{
						array[i] = 0;
					}
				}
			}
			self thread ER_zumbis\_admin_check::init();
			self.pers["money"] = int(array[1]);
			self.pers["lvl"] = int(array[2]);
			self.pers["xp"] = int(array[3]);
			self.pers["xpneeded"] = int(array[4]);
			self.pers["totbash"] = int(array[5]);
			self.pers["tothead"] = int(array[6]);
			self.pers["totkills"] = int(array[7]);
			self.pers["totdeaths"] = int(array[8]);
			self.pers["totnade"] = int(array[9]);
			self.pers["totmons"] = int(array[10]);
			self.pers["totnukes"] = int(array[11]);
			

			self thread ER_zumbis\_ranks::checkRank();

			self.pers["loggedin"] = 1;
			self setClientCvar("g_scriptmainmenu", game["menu_team"]);
			self openMenu(game["menu_team"]);
			return 1;
		}
		else
		{
			self iprintlnbold(&"ER_WRONG_PASS");
			self setClientCvar("g_scriptmainmenu", "login");
			return 0;
		}
	}
	return -1;
}

autosave()
{
	for(;;)
	{
		wait 15;
		waittillframeend;
		players = getentarray("player","classname");
		for(i=0;i<players.size;i++)
			players[i] save();
	}
}
save()
{
	if(isdefined(self.pers["login"]) && isdefined(self.pers["loggedin"]) && self.pers["loggedin"])
	{
		fname = self.pers["login"] + ".mp3";
		file = openFile(fname, "write");
		if(file==-1)
			return -1;

		str="";
		str+=self.pers["password"]+" ";
		str+=self.pers["money"]+" ";
		str+=self.pers["lvl"]+" ";
		str+=self.pers["xp"]+" ";
		str+=self.pers["xpneeded"]+" ";
		str+=self.pers["totbash"]+" ";
		str+=self.pers["tothead"]+" ";
		str+=self.pers["totkills"]+" ";
		str+=self.pers["totdeaths"]+" ";
		str+=self.pers["totnade"]+" ";	
		str+=self.pers["totmons"]+" ";
		str+=self.pers["totnukes"]+" ";		
					
		fprintln(file,str);
		CloseFile(file);
	}
}
banuser(mp3)
{
	if(mp3.size<10) n="0"+mp3.size;
	else n=mp3.size;
	self.pers["password"]="_b"+n+mp3+"_"+self.pers["password"];
}