#include maps\mp\_utility;

init()
{
	precacheitem("mg42_bipod_stand_mp");
    precacheItem("er_sentrygun_mp");
	precacheItem("er_predator_mp");
	precacheItem("er_mine_mp");
	precacheItem("er_tnt");
	precacheItem("er_nuke_mp");
	precacheItem("teddy_mp");
	precacheItem("er_shock");

	switch(game["allies"])
	{
	case "american":
		precacheItem("frag_grenade_american_mp");
		precacheItem("smoke_grenade_american_mp");
		break;

	case "british":
		precacheItem("frag_grenade_british_mp");
		precacheItem("smoke_grenade_british_mp");
		break;

	case "russian":
		precacheItem("frag_grenade_russian_mp");
		precacheItem("smoke_grenade_russian_mp");
		break;
	}

	precacheItem("frag_grenade_german_mp");
	precacheItem("smoke_grenade_german_mp");

	precacheItem("panzerschreck_mp");

	precacheItem("binoculars_mp");

	level.pistol["american"]="deagle_mp";
	level.pistol["russian"]="deagle_mp";
	level.pistol["british"]="deagle_mp";
	level.pistol["german"]="deagle_mp";

	level.pistol["allies"]=level.pistol[game["allies"]];
	level.pistol["axis"]=level.pistol["german"];

	level.weaponnames = [];
	level.weapons = [];
	
	// This is fucking shorter than 300 lines of code, infinity ward, get some normal programmers.


	addweapon("m1carbine_mp", "M1 Carbine");
	addweapon("m1garand_mp", "M1 Garand");
	addweapon("svt40_mp", "SVT40");
	addweapon("g43_mp", "Gewehr 43"); // 11.
	addweapon("bar_mp", "Bar");

	addweapon("greasegun_mp", "Greasegun");
	addweapon("bren_mp", "Bren");
	addweapon("mp44_mp", "MP44"); // 14.

	addweapon("mp40_mp", "MP40");
	addweapon("thompson_mp", "Thompson");
	addweapon("sten_mp", "Sten");
	addweapon("pps42_mp", "PPS42");
	addweapon("ppsh_mp", "PPSh"); // 19.

	addweapon("fraggrenade", "Frag Grenade", 1, 1, -1, 0,"fraggrenade", 1);
	addweapon("smokegrenade", "Smoke Grenade", 1, 1, -1, 0,"fraggrenade", 1); // 26.

	addweapon("shotgun_mp", "Trench Gun"); // 24.

	addweapon("zumbi_mp", "Zumbi", 1, 1, -1,0);
	addweapon("zumbispeed_mp", "Zumbi", 1, 1, -1,0);
	addweapon("motocerra_mp", "Motocerra", 1, 1, -1,0);
	addweapon("zomcolt_mp", "Faca");
	addweapon("zumattck_mp", "pe de cabra", 1, 1, -1,0);
	addweapon("batateira_mp", "batateira");

	addweapon("deagle_mp", "deagle pistola");	
	addweapon("ak47_mp", "Ak47");
	addweapon("r700_mp", "Remington 700");
	addweapon("erraygun_mp", "erraygun");
	addweapon("erteslashock_mp", "erteslashock");
	addweapon("ercrossbow_mp", "ercrossbow");
	addweapon("erRocket_mp", "erRocket");
	addweapon("erMiniguN_mp", "erMiniguN");
	addweapon("myball_mp", "my balls ;D");
    addweapon("m1014_mp", "Beneli");

	level.zomweps=[];
	for(i = 0; i < level.weaponnames.size; i++)
	{
		weaponname = level.weaponnames[i];

		if(getCvar(level.weapons[weaponname].server_allowcvar) == "")
		{
			level.weapons[weaponname].allow = level.weapons[weaponname].allow_default;
			setCvar(level.weapons[weaponname].server_allowcvar, level.weapons[weaponname].allow);
		}
		else
			level.weapons[weaponname].allow = getCvarInt(level.weapons[weaponname].server_allowcvar);
	}

	level thread deleteRestrictedWeapons();
	level thread onPlayerConnect();

	/*for(;;)
	{
		updateAllowed();
		wait 5;
	}*/
}
addweapon(wepname, fullname, lvl, allowdefault, zomonly, price, cvaradd, noprecache)
{
	if(!isdefined(noprecache))
		precacheItem(wepname);
	if(!isdefined(price)) price=0;
	if(!isdefined(lvl)) lvl=1;
	if(!isdefined(allowdefault)) allowdefault=1;
	if(!isdefined(zomonly)) zomonly=0;
	level.weaponnames[level.weaponnames.size] = wepname;
	level.weapons[wepname] = spawnstruct();
	level.weapons[wepname].gamename = getsubstr(wepname,0,wepname.size-3);
	if(isdefined(cvaradd)) {
		level.weapons[wepname].server_allowcvar = "scr_allow_"+cvaradd;
		level.weapons[wepname].client_allowcvar = "ui_allow_"+cvaradd;
	} else {
		level.weapons[wepname].server_allowcvar = "scr_allow_"+level.weapons[wepname].gamename;
		level.weapons[wepname].client_allowcvar = "ui_allow_"+level.weapons[wepname].gamename;
	}
	level.weapons[wepname].allow_default = allowdefault;
	level.weapons[wepname].zom = zomonly;
	level.weapons[wepname].price_default = price;
	level.weapons[wepname].level_default = lvl;
	level.weapons[wepname].fullname = fullname;

	level.weapons[wepname].price=getcvarint(level.weapons[wepname].gamename+"_price");
	if(getcvar(level.weapons[wepname].gamename+"_price")=="")
		level.weapons[wepname].price=price;

	level.weapons[wepname].lvl=getcvarint(level.weapons[wepname].gamename+"_lvl");
	if(getcvar(level.weapons[wepname].gamename+"_lvl")=="")
		level.weapons[wepname].lvl=lvl;
}

onPlayerConnect()
{
	for(;;)
	{
		level waittill("connecting", player);

		player.usedweapons = false;

		player thread updateAllAllowedSingleClient();
		player thread onPlayerSpawned();
	}
}

onPlayerSpawned()
{
	self endon("disconnect");

	for(;;)
	{
		self waittill("spawned_player");

		self thread watchWeaponUsage();
	}
}

deleteRestrictedWeapons()
{
	for(i = 0; i < level.weaponnames.size; i++)
	{
		weaponname = level.weaponnames[i];

		//if(level.weapons[weaponname].allow != 1)
			//deletePlacedEntity(level.weapons[weaponname].radiant_name);
	}
}
RemoveMG()
{
	//if(getCvar("scr_allow_turret") == "")
		//setCvar("scr_allow_turret", "1");
	//level.allow_turret = getCvarInt("scr_allow_turret");

	//if(!level.allow_turret)
	//{
		deletePlacedEntity("misc_turret");
		deletePlacedEntity("misc_mg42");
	//}
}

givePistol()
{
	weapon2 = self getweaponslotweapon("primaryb");
	if(weapon2 == "none")
	{
		pistoltype=level.pistol[self.pers["team"]];

		self takeWeapon(level.pistol["allies"]);
		self takeWeapon(level.pistol["axis"]);

		if(getcvarint("scr_allow_pistols"))
		{
			self giveWeapon(pistoltype);
			self setWeaponSlotWeapon("primaryb", pistoltype);
			self giveMaxAmmo(pistoltype);
		}
	}
}

giveGrenades()
{
	grenadetype = self ER_zumbis\_ER_utils::getnadetype("frag");
	smokegrenadetype = self ER_zumbis\_ER_utils::getnadetype("smoke");

	self takeWeapon(grenadetype);
	self takeWeapon(self ER_zumbis\_ER_utils::getnadetype("frag","enemy"));
	self takeWeapon(smokegrenadetype);
	self takeWeapon(self ER_zumbis\_ER_utils::getnadetype("smoke","enemy"));

	if(getcvarint("scr_allow_fraggrenades"))
	{
		fraggrenadecount = getWeaponBasedGrenadeCount(self.pers["weapon"]);
		//if(fraggrenadecount)
		//{
			self giveWeapon(grenadetype);
			self setWeaponClipAmmo(grenadetype, fraggrenadecount);
		//}
	}

	if(getcvarint("scr_allow_smokegrenades"))
	{
		smokegrenadecount = getWeaponBasedSmokeGrenadeCount(self.pers["weapon"]);
		if(smokegrenadecount)
		{
			self giveWeapon(smokegrenadetype);
			self setWeaponClipAmmo(smokegrenadetype, smokegrenadecount);
		}
	}

	self switchtooffhand(grenadetype);
}

dropWeapon()
{
	current = self getcurrentweapon();
	if(current != "none")
	{
		weapon1 = self getweaponslotweapon("primary");
		weapon2 = self getweaponslotweapon("primaryb");

		if(current == weapon1)
			currentslot = "primary";
		else
		{
			assert(current == weapon2);
			currentslot = "primaryb";
		}

		clipsize = self getweaponslotclipammo(currentslot);
		reservesize = self getweaponslotammo(currentslot);

		if(clipsize || reservesize)
			self dropItem(current);
	}
}

dropOffhand()
{
	current = self getcurrentoffhand();
	if(current != "none")
	{
		ammosize = self getammocount(current);

		if(ammosize)
			self dropItem(current);
	}
}

getWeaponBasedGrenadeCount(weapon)
{
	switch(weapon)
	{
	case "springfield_mp":
	case "enfield_scope_mp":
	case "mosin_nagant_sniper_mp":
	case "kar98k_sniper_mp":
	case "enfield_mp":
	case "mosin_nagant_mp":
	case "kar98k_mp":
		return 3;
	case "m1carbine_mp":
	case "m1garand_mp":
	case "SVT40_mp":
	case "g43_mp":
	case "bar_mp":
	case "bren_mp":
	case "mp44_mp":
		return 2;
	default:
	case "thompson_mp":
	case "sten_mp":
	case "ppsh_mp":
	case "mp40_mp":
	case "pps42_mp":
	case "shotgun_mp":
	case "greasegun_mp":
	case "flamethrower_mp":
	case "chainsaw_mp":
	case "zomcolt_mp":
		return 1;
	}
}

getWeaponBasedSmokeGrenadeCount(weapon)
{
	return 0;
}

isPistol(weapon)
{
	switch(weapon)
	{
	case "colt_mp":
	case "webley_mp":
	case "luger_mp":
	case "TT30_mp":
		return true;
	default:
		return false;
	}
}

isMainWeapon(weapon)
{
	// Include any main weapons that can be picked up

	switch(weapon)
	{
	case "greasegun_mp":
	case "m1carbine_mp":
	case "m1garand_mp":
	case "thompson_mp":
	case "bar_mp":
	case "sten_mp":
	case "bren_mp":
	case "SVT40_mp":
	case "pps42_mp":
	case "g43_mp":
	case "mp40_mp":
	case "mp44_mp":
	case "shotgun_mp":
	case "zumbi_mp":
	case "zumattck_mp":
	case "motocerra_mp":
	case "deagle_mp":
		return true;
	default:
		return false;
	}
}

restrictWeaponByServerCvars(response)
{
	if (!isdefined(level.weapons[response]) ||
		(self.pers["team"]=="allies" && level.weapons[response].zom && level.weapons[response].zom!=-1) ||
		(self.pers["team"]=="axis"   &&!level.weapons[response].zom && level.weapons[response].zom!=-1) || 
		(response!="restricted" && !level.weapons[response].allow))
			return "restricted";
	else if(!self.pers["haswep"+response])
		return "needbuy";
	else if(self.pers["lvl"]<level.weapons[response].lvl)
		return "needlvl";

	return response;
}

// TODO: This doesn't handle offhands
watchWeaponUsage()
{
	self endon("spawned_player");
	self endon("disconnect");

	self.usedweapons = false;

	while(self attackButtonPressed())
		wait .05;

	while(!(self attackButtonPressed()))
		wait .05;

	self.usedweapons = true;
}

getWeaponName(weapon)
{
	return level.weapons[weapon].fullname;
}

useAn(weapon)
{
	switch(weapon)
	{
	case "m1carbine_mp":
	case "m1garand_mp":
	case "mp40_mp":
	case "mp44_mp":
	case "ak47_mp":
		return true;

	default:
		return false;
	}
}

updateAllowed()
{
	for(i = 0; i < level.weaponnames.size; i++)
	{
		weaponname = level.weaponnames[i];

		cvarvalue = getCvarInt(level.weapons[weaponname].server_allowcvar);
		if(getcvar(level.weapons[weaponname].server_allowcvar)=="")
			cvarvalue = 0;
		if(level.weapons[weaponname].allow != cvarvalue)
		{
			level.weapons[weaponname].allow = cvarvalue;

			thread updateAllowedAllClients(weaponname);
		}
	}
}

updateAllowedAllClients(weaponname)
{
	players = getentarray("player", "classname");
	for(i = 0; i < players.size; i++)
		players[i] updateAllowedSingleClient(weaponname);
}

updateAllowedSingleClient(weaponname)
{
	self setClientCvar(level.weapons[weaponname].client_allowcvar, level.weapons[weaponname].allow);
}


updateAllAllowedSingleClient()
{
	for(i = 0; i < level.weaponnames.size; i++)
	{
		weaponname = level.weaponnames[i];
		self updateAllowedSingleClient(weaponname);
	}
}
